                        .MODEL  SMALL
                        INCLUDE CRT.INC
                        INCLUDE DOS.INC


                        .DATA
;---------------------------------------------------------------
CR              EQU     0DH
LF              EQU     0AH

;------------------------   --------------------------
KESC            EQU     27
KUP             EQU     72
KDOWN           EQU     80
KPGUP           EQU     73
KPGDN           EQU     81

;------------------------   --------------------------
E_OK            EQU     0
E_ERR           EQU     NOT E_OK

;--------------------    ----------------------
BSIZE           EQU     32768

;---------------------    ----------------------
WHEIGHT         EQU     23

;---------------    -----------------
TSEG            DW      0B000H

;--------------------------  --------------------------
EM_USAGE        DB      "USAGE: FCOMVIEW.EXE <TEXTFILE>",0
EM_OPEN         DB      "CAN'T OPEN FILE ",0
EM_EMPTY        DB      "CAN'T OUTPUT AN EMPTY FILE!!!",0
E_STATUS        DB      "ESC-QUIT; UP,DOWN,PAGEUP,PAGEDOWN-SCROLL TEXT.    ",
                        "VIEWER BY FRUNZE A.A. 1996(C).",0

;-------------      -------------
ERROR           DB      E_OK

;---------------------    --------------------
FSMALL          DB      0

;-----------------  /  -----------------
FEOF            DB      0
FBOF            DB      0FFH

;-------------------------   -------------------------
FHANDLE         DW      0

;----------------------    -----------------------
BPOS            DW      0

;-----------------    -----------------
READED          DW      0

;------------       ------------
X               DB      0
Y               DB      0

;--------------------------   --------------------------
FNAME           DB      128     DUP (0)

;-----------------------    ----------------------
STRING          DB      256     DUP (0)

;-------------------------   -------------------------
BUF             DB      BSIZE   DUP (?)

;----------------     -----------------
STRINGS         DB      WHEIGHT*256 DUP (?)

;---------------------------------------------------------------
                        .CODE
                        .STARTUP
;---------------------------------------------------------------
        MOV             AX, DGROUP
        MOV             DS, AX
        MOV             ES, AX
        CALL            GETTSEG
        @CLRSCR
        @GOTOXY         0, 0
        CALL            GETNAME
        CMP             ERROR, E_OK
        JNE             P_END
        MOV             BX, OFFSET FNAME
        CALL            STRUP
        @OPENFILE       FNAME
        MOV             FHANDLE, AX
        JNC             P_L1
        MOV             BX, OFFSET EM_OPEN
        CALL            WRITE
        MOV             BX, OFFSET FNAME
        CALL            WRITELN
        JMP             P_END
P_L1:
        @READ           BUF, BSIZE, FHANDLE
        MOV             READED, AX
        CMP             AX, 0
        JNE             P_L2
        MOV             BX, OFFSET EM_EMPTY
        CALL            WRITELN
        JMP             P_CEND
P_L2:
        CALL            MAKESCR
        CALL            FWRITE
KEY:
        @KEYPRESSED
        JZ              KEY
        @READKEY
        CMP             AL, KESC
        JNE             K_1
        CALL            NORMSCR
        JMP             P_CEND
K_1:
K_EXT:
        CMP             AL, 0
        JNE             KEY
        CMP             AH, KUP
        JNE             K_E1
        CALL            UP
        JMP             KEY
K_E1:
        CMP             AH, KDOWN
        JNE             K_E2
        CALL            DOWN
        JMP             KEY
K_E2:
        CMP             AH, KPGUP
        JNE             K_E3
        CALL            PAGEUP
        JMP             KEY
K_E3:
        CMP             AH, KPGDN
        JNE             K_E4
        CALL            PAGEDOWN
K_E4:
        JMP             KEY
P_CEND:
        @CLOSEFILE      FHANDLE
P_END:
        @EXIT
;---------------------------------------------------------------
PAGEUP          PROC    NEAR
;  .
        CMP             FSMALL, 0
        JNE             PUP_END
        CMP             FBOF, 0
        JNE             PUP_END

        MOV             CX, WHEIGHT
PUP_L0:
        PUSH            CX
        CALL            FREADB
        POP             CX
        LOOP            PUP_L0

        MOV             CX, 0
        MOV             DI, OFFSET STRINGS
PUP_L1:
        PUSH            CX
        PUSH            DI
        CALL            FREADB
        PUSH            AX
        MOV             SI, OFFSET STRING
        CALL            STRCOPY
        POP             AX
        POP             DI
        ADD             DI, 256
        POP             CX
        INC             CX
        CMP             AL, 0
        JE              PUP_L2
        MOV             FBOF, 0FFH
        JMP             PUP_L3
PUP_L2:
        CMP             CX, WHEIGHT
        JNE             PUP_L1
PUP_L3:
        PUSH            CX
        @WINDOW         0, 1, 80, 23
        POP             CX
        PUSH            CX
        @SCROLLDOWN     CL
        @WINDOW         0, 0, 80, 25
        POP             CX
        MOV             BX, OFFSET STRINGS
PUP_L4:
        PUSH            CX
        PUSH            BX
        MOV             AH, CL
        MOV             AL, 0
        CALL            GOTOXY
        POP             BX
        PUSH            BX
        CALL            WRITE2
        POP             BX
        POP             CX
        ADD             BX, 256
        LOOP            PUP_L4
        MOV             CX, WHEIGHT
PUP_L5:
        PUSH            CX
        CALL            FREAD
        POP             CX
        LOOP            PUP_L5
        MOV             FEOF, 0
PUP_END:
        RET
PAGEUP          ENDP

PAGEDOWN        PROC    NEAR
;  .
        CMP             FSMALL, 0
        JNE             PDN_END
        CMP             FEOF, 0
        JNE             PDN_END
        MOV             CX, 0
        MOV             DI, OFFSET STRINGS
PDN_L1:
        PUSH            CX
        PUSH            DI
        CALL            FREAD
        PUSH            AX
        MOV             SI, OFFSET STRING
        CALL            STRCOPY
        POP             AX
        POP             DI
        ADD             DI, 256
        POP             CX
        INC             CX
        CMP             AL, 0
        JE              PDN_L2
        MOV             FEOF, 0FFH
        JMP             PDN_L3
PDN_L2:
        CMP             CX, WHEIGHT
        JNE             PDN_L1
PDN_L3:
        PUSH            CX
        @WINDOW         0, 1, 80, 23
        POP             CX
        PUSH            CX
        @SCROLLUP       CL
        @WINDOW         0, 0, 80, 25
        POP             CX
        MOV             BX, OFFSET STRINGS
PDN_L4:
        PUSH            CX
        PUSH            BX
        MOV             AL, WHEIGHT+1
        SUB             AL, CL
        MOV             AH, AL
        MOV             AL, 0
        CALL            GOTOXY
        POP             BX
        PUSH            BX
        CALL            WRITE2
        POP             BX
        POP             CX
        ADD             BX, 256
        LOOP            PDN_L4
        MOV             FBOF, 0
PDN_END:
        RET
PAGEDOWN        ENDP

UP              PROC    NEAR
;  .
        CMP             FSMALL, 0
        JNE             UP_END
        CMP             FBOF, 0
        JNE             UP_END
        MOV             CX, WHEIGHT
UP_L1:
        PUSH            CX
        CALL            FREADB
        POP             CX
        LOOP            UP_L1
        CALL            FREADB
        MOV             FBOF, AL
        @WINDOW         0, 1, 80, WHEIGHT
        @SCROLLDOWN     1
        @WINDOW         0, 0, 80, 25
        MOV             AX, 0100H
        CALL            GOTOXY
        MOV             BX, OFFSET STRING
        CALL            WRITE2
        MOV             CX, WHEIGHT
UP_L2:
        PUSH            CX
        CALL            FREAD
        POP             CX
        LOOP            UP_L2
        MOV             FEOF, 0
UP_END:
        RET
UP              ENDP

DOWN            PROC    NEAR
;  .
        CMP             FSMALL, 0
        JNE             DN_END
        CMP             FEOF, 0
        JNE             DN_END
        CALL            FREAD
        MOV             FEOF, AL
        @WINDOW         0, 1, 80, WHEIGHT
        @SCROLLUP       1
        @WINDOW         0, 0, 80, 25
        MOV             AH, WHEIGHT
        MOV             AL, 0
        CALL            GOTOXY
        MOV             BX, OFFSET STRING
        CALL            WRITE2
        MOV             FBOF, 0
DN_END: 
        RET
DOWN            ENDP

FWRITE          PROC    NEAR
;  .
        @GOTOXY         0, 1
        MOV             CX, WHEIGHT
FW_L:
        PUSH            CX
        CALL            FREAD
        PUSH            AX
        MOV             BX, OFFSET STRING
        CALL            WRITELN
        POP             AX
        CMP             AL, 0
        JE              FW_L1
        POP             CX
        PUSH            CX
        CMP             CX, 1
        JE              FW_L1
        DEC             FSMALL
        POP             CX
        MOV             CX, 1
        PUSH            CX
FW_L1:
        POP             CX
        LOOP            FW_L
        RET
FWRITE          ENDP

MAKESCR         PROC    NEAR
; .
        @WINDOW         0, 0, 80, 1
        @SETCOLOR       BLACK, CYAN
        @CLRSCR
        @GOTOXY         0, 0
        MOV             BX, OFFSET FNAME
        CALL            WRITE
        @WINDOW         0, 24, 80, 1
        @SETCOLOR       BLACK, CYAN
        @CLRSCR
        @WINDOW         0, 1, 80, 23
        @SETCOLOR       LCYAN, BLUE
        @CLRSCR
        @WINDOW         0, 0, 80, 25
        MOV             AH, 24
        MOV             AL, 0
        CALL            GOTOXY
        @SETCOLOR       BLACK, CYAN
        MOV             BX, OFFSET E_STATUS
        CALL            WRITE2
        @SETCOLOR       LCYAN, BLUE
        @CURSOROFF
        RET
MAKESCR         ENDP

NORMSCR         PROC    NEAR
; .
        @WINDOW         0, 0, 80, 25
        @GOTOXY         0, 0
        @CURSORON
        @SETCOLOR       GRAY, BLACK
        @CLRSCR
        RET
NORMSCR         ENDP

FREAD           PROC    NEAR
; .
;: AL <> 0 -  .
        MOV             AX, OFFSET STRING
        MOV             SI, AX
        XOR             DL, DL
        PUSH            DX
FR_LP1:
        MOV             BX, OFFSET BUF
        ADD             BX, BPOS
        MOV             AL, [BX]
        CMP             AL, CR
        JNE             FR_L1
        POP             DX
        MOV             DL, 1
        PUSH            DX
FR_L1:
        INC             BPOS
        MOV             CX, READED
        CMP             CX, BPOS
        JNE             FR_L3
        CMP             BPOS, BSIZE
        JE              FR_L2
        CMP             DL, 0
        JNE             FR_L5
        MOV             [SI], AL
        INC             SI
        JMP             FR_L5
FR_L2:
        PUSH            AX
        @READ           BUF, BSIZE, FHANDLE
        MOV             READED, AX
        MOV             BPOS, 0
        POP             AX
        JMP             FR_L3
FR_L5:
        MOV             AL, 0FFH
        JMP             FR_END
FR_L3:
        POP             DX
        CMP             DL, 0
        PUSH            DX
        JE              FR_L4
        POP             DX
        INC             DL
        PUSH            DX
        CMP             DL, 2
        JE              FR_LP1
        CMP             DL, 3
        JNE             FR_L4
        XOR             AL, AL
        JMP             FR_END
FR_L4:
        MOV             [SI], AL
        INC             SI
        JMP             FR_LP1
FR_END:
        POP             DX
        XOR             AH, AH
        MOV             [SI], AH
        RET
FREAD           ENDP

FREADB          PROC    NEAR
;  .
;: AL <> 0 -  .
        MOV             AX, OFFSET STRING
        MOV             SI, AX
        MOV             CX, READED
        CMP             CX, BPOS
        JNE             FR_L2
        DEC             BPOS
        MOV             BX, OFFSET BUF
        ADD             BX, BPOS
        MOV             AL, [BX]
        CMP             AL, LF
        JNE             FR_L5
        INC             BPOS
        JMP             FR_L2
FR_L2:
        MOV             CX, 3
FR_LP1:
        PUSH            CX
        DEC             BPOS
        CMP             BPOS, -1
        JNE             FR_L3
        @MOVEPTRREL     FHANDLE, 0
        MOV             CX, BSIZE
        DIV             CX
        CMP             AX, 0
        JE              FR_L4
        CMP             AX, 1
        JNE             X0
        CMP             READED, BSIZE
        JE              FR_L4
        DEC             AX
        JMP             MOVE1
X0:
        DEC             AX
        CMP             READED, BSIZE
        JNE             MOVE1
        DEC             AX
MOVE1:
        MOV             CX, BSIZE
        MUL             CX
        MOV             CX, DX
        MOV             DX, AX
        @MOVEPTRABS     FHANDLE
        @READ           BUF, BSIZE, FHANDLE
        MOV             READED, BSIZE
        MOV             BPOS, BSIZE-1
        JMP             FR_L3
FR_L4:
        POP             CX
FR_L1:
        MOV             BPOS, 0
        MOV             AL, 0FFH
        JMP             FR_END
FR_L3:
        POP             CX
        LOOP            FR_LP1
FR_L5:
        MOV             BX, OFFSET BUF
        ADD             BX, BPOS
        MOV             AL, [BX]
        CMP             AL, LF
        JNE             FR_L6
        INC             BPOS
        MOV             CX, READED
        CMP             CX, BPOS
        JE              FR_L7
        XOR             AL, AL
        JMP             FR_END
FR_L7:
        @READ           BUF, BSIZE, FHANDLE
        MOV             READED, AX
        MOV             BPOS, 0
        XOR             AL, AL
        JMP             FR_END
FR_L6:
        MOV             [SI], AL
        INC             SI
        DEC             BPOS
        CMP             BPOS, -1
        JNE             FR_L5
        @MOVEPTRREL     FHANDLE, 0
        MOV             CX, BSIZE
        DIV             CX
        CMP             AX, 0
        JE              FR_L1
        CMP             AX, 1
        JNE             X1
        CMP             READED, BSIZE
        JE              FR_L1
        DEC             AX
        JMP             MOVE2
X1:
        DEC             AX
        CMP             READED, BSIZE
        JNE             MOVE2
        DEC             AX
MOVE2:
        MOV             CX, BSIZE
        MUL             CX
        MOV             CX, DX
        MOV             DX, AX
        @MOVEPTRABS     FHANDLE
        @READ           BUF, BSIZE, FHANDLE
        MOV             READED, BSIZE
        MOV             BPOS, BSIZE-1
        JMP             FR_L5
FR_END:
        XOR             AH, AH
        MOV             [SI], AH
        PUSH            AX
        MOV             BX, OFFSET STRING
        CALL            STRINGMIRROR
        POP             AX
        RET
FREADB          ENDP

GETNAME         PROC    NEAR
;  FNAME  .
        PUSH            DS
        MOV             AH, 51H
        INT             21H
        MOV             DS, BX                  ;DS=PSP SEGMENT

        MOV             BX, 80H
        XOR             CH, CH
        MOV             CL, [BX]
        CMP             CL, 0
        JE              GN_L2                   ; .
GN_LP1:
        CMP             CL, 0
        JE              GN_L1
        INC             BX
        MOV             AL, [BX]
        DEC             CL
        CMP             AL, " "
        JE              GN_LP1                  ;  .
        INC             CL
GN_L1:
        MOV             SI, OFFSET FNAME
GN_LP2:
        CMP             CX, 0
        JE              GN_L2
        MOV             AL, [BX]
        MOV             ES:[SI], AL
        INC             BX
        INC             SI
        LOOP            GN_LP2                  ; .
GN_L2:
        POP             DS
        MOV             BX, OFFSET FNAME
        CALL            STRLEN
        CMP             AX, 0
        JNE             GN_END
        MOV             BX, OFFSET EM_USAGE     ; -.
        CALL            WRITELN
        MOV             ERROR, E_ERR
GN_END:
        RET
GETNAME         ENDP

WRITE           PROC    NEAR
;   ASCIIZ-.
        XOR             CX, CX
WS_BEG:
        PUSH            CX
        PUSH            BX
        MOV             AL, [BX]
        CMP             AL, 0
        JE              WS_E
        @WRITECHAR      AL
        @MOVEXY         1, 0
        POP             BX
        POP             CX
        INC             BX
        INC             CX
        CMP             CX, 80
        JE              WS_END
        JMP             WS_BEG
WS_E:
        POP             BX
        POP             CX
WS_END:
        RET
WRITE           ENDP

WRITELN         PROC    NEAR
;   ASCIIZ-   .
        CALL            WRITE
        @MOVEXY         0, 1
        @GOTOXY         0
        RET
WRITELN         ENDP

WAL             PROC    NEAR
;   AL  . ,    .
        PUSH            AX
        MOV             BH, 10
        MOV             CX, 2
WAL_LP1:
        XOR             AH, AH
        DIV             BH
        PUSH            AX
        LOOP            WAL_LP1
        MOV             AH, AL
        MOV             CX, 3
WAL_LP2:
        MOV             AL, AH
        CMP             AL, 0
        JE              WAL_L1
        MOV             CH, 1
WAL_L1: 
        CMP             CH, 0
        JE              WAL_L2
        ADD             AL, 10H
WAL_L2:
        ADD             AL, 20H
        PUSH            CX
        @WRITECHAR      AL
        @MOVEXY         1, 0
        POP             CX
        POP             AX
        DEC             CL
        CMP             CL, 1
        JNE             WAL_L3
        MOV             CH, 1
WAL_L3:
        CMP             CL, 0
        JNE             WAL_LP2
        RET
WAL             ENDP

WAX             PROC    NEAR
;   AX  . ,    .
        PUSH            AX
        MOV             BX, 10
        MOV             CX, 4
WAX_LP1:
        XOR             DX, DX
        DIV             BX
        PUSH            DX
        LOOP            WAX_LP1
        MOV             AH, AL
        MOV             CX, 5
WAX_LP2:
        MOV             AL, AH
        CMP             AL, 0
        JE              WAX_L1
        MOV             CH, 1
WAX_L1: 
        CMP             CH, 0
        JE              WAX_L2
        ADD             AL, 10H
WAX_L2:
        ADD             AL, 20H
        PUSH            CX
        @WRITECHAR      AL
        @MOVEXY         1, 0
        POP             CX
        POP             AX
        MOV             AH, AL
        DEC             CL
        CMP             CL, 1
        JNE             WAX_L3
        MOV             CH, 1
WAX_L3:
        CMP             CL, 0
        JNE             WAX_LP2
        RET
WAX             ENDP

STRINGMIRROR    PROC    NEAR
; ,     BX.
        CALL            STRLEN
        CMP             AX, 2
        JL              SM_END
        PUSH            BX
        MOV             DX, BX
        ADD             DX, AX
        DEC             DX
        PUSH            DX
        POP             SI
        SHR             AX, 1
        MOV             CX, AX
SM_L1:
        MOV             AL, [BX]
        MOV             AH, [SI]
        MOV             [BX], AH
        MOV             [SI], AL
        INC             BX
        DEC             SI
        LOOP            SM_L1
        POP             BX
SM_END:
        RET
STRINGMIRROR    ENDP

STRLEN          PROC    NEAR
;  AX  ASCIIZ-,     BX.
        PUSH            BX
        MOV             AX, -1
SL_LOOP:
        INC             AX
        MOV             CL, [BX]
        INC             BX
        CMP             CL, 0
        JNE             SL_LOOP
        POP             BX
        RET
STRLEN          ENDP

STRUP           PROC    NEAR
;  (  BX)   .
        PUSH            BX
        DEC             BX
SU_LOOP:
        INC             BX
        MOV             AL, [BX]
        CMP             AL, 0
        JE              SU_END
        CMP             AL, 'a'
        JL              SU_LOOP
        CMP             AL, 'z'
        JG              SU_LOOP
        SUB             BYTE PTR[BX], 20H
        JMP             SU_LOOP
SU_END:
        POP             BX
        RET
STRUP           ENDP

STRCOPY         PROC    NEAR
;  (DI<--SI).
STC_L:
        MOV             AL, [SI]
        MOV             [DI], AL
        CMP             AL, 0
        JE              STC_END
        INC             SI
        INC             DI
        JMP             STC_L
STC_END:
        RET
STRCOPY         ENDP

GETTSEG         PROC    NEAR
;  TSEG   .
        PUSH            DS
        XOR             AX, AX
        MOV             DS, AX
        MOV             AL, DS:[410H]
        POP             DS
        AND             AL, 30H
        CMP             AL, 30H
        JE              GTS_END
        MOV             TSEG, 0B800H
GTS_END:
        RET
GETTSEG         ENDP

GOTOXY          PROC    NEAR
;  AH=Y,AL=X (    ).
        MOV             Y, AH
        MOV             X, AL
        RET
GOTOXY          ENDP

WRCHAR          PROC    NEAR
;  (AL) (   ).
        PUSH            AX
        XOR             AH, AH
        MOV             AL, WY
        ADD             AL, Y
        MOV             CL, 80
        MUL             CL
        ADD             AL, WX
        ADC             AH, 0
        ADD             AL, X
        ADC             AH, 0
        SHL             AX, 1
        MOV             BX, AX          ;BX=Y*160+X*2
        MOV             CX, DS
        MOV             AX, ES:TSEG
        MOV             DS, AX
        POP             AX
        MOV             DS:[BX], AL
        INC             BX
        MOV             AL, ES:TXTATTR
        MOV             DS:[BX], AL
        MOV             DS, CX
        RET
WRCHAR          ENDP

WRITE2          PROC    NEAR
; ASCIIZ- (   ).
        XOR             CX, CX
WS_BEG:
        PUSH            CX
        PUSH            BX
        MOV             AL, [BX]
        CMP             AL, 0
        JE              WS_E
        CALL            WRCHAR
        INC             X
        POP             BX
        POP             CX
        INC             BX
        INC             CX
        CMP             CX, 80
        JE              WS_END
        JMP             WS_BEG
WS_E:
        POP             BX
        POP             CX
WS_END:
        RET
WRITE2          ENDP
;---------------------------------------------------------------

                        .STACK 4096

                        END
