Unit FCU;

Interface

Uses
  DOS,
  Drives,
  Printer,
  CRT,
  ProfText,
  Text_Abs,
  Movies,
  S_Input,
  FCMouse,
  FCP;

Const
  MaxDirSize = 1000;
  Per = '0%  100%';
{ * Names * }
  BAT = 'TEMP.BAT';
  MNU = 'FCOM.MNU';
  SEL = 'FCOM.SEL';
  TMP = 'FCOM.TMP';
  CFG = 'FCOM.CFG';
  FM  = 'FCOM.MEM';
  DM  = 'MEM.EXE';
  Edit= 'FCOMEDIT.EXE';
  View= 'FCOMVIEW.EXE';
{ * Errors * }
  Ok          =  0;
  NoSpace     = -1;
  ReadError   = -2;
  WriteError  = -3;
  DeleteError = -4;
  RenameError = -5;
  MakeError   = -6;
{ * Error messages * }
  Message : Array [1..6] of String[27] =
    (' Not enough space to write ', '  Can''t read the  ',
     '  Can''t write the  ', '  Can''t delete the  ',
     '  Cant'' rename the  ', '  Can''t make the  ');
{ * Buttons * }
  BOk = '[ Ok ]';
  BCancel = '[ Cancel ]';
  BCopy = '[ Copy ]';
  BMove = '[ Move ]';
  BDelete = '[ Delete ]';
  BSave   = '[  Save  ]';
Type
  DirRec   = Record
               Attr : Byte;
               Time,
               Size : Longint;
               Name : String[12];
               Sel  : Boolean
             End;
  DirList  = Array [0..MaxDirSize - 1] of DirRec;
  LessFunc = Function (X, Y : DirRec) : Boolean;
  Buffer   = Array[0..32767] of Byte;
  VBuffer  = Array[0..7999] of Byte;
  FName    = String[12];
  FRec     = Record
    Name : Fname;
    DirN : Byte;
    Time,
    Size : LongInt;
  End;
  FRA      = Array [1..1000] of FRec;
  OptRec   = Record
               LDir,
               RDir,
               ExView1,
               ExView2,
               ExEdit1,
               LFile,
               RFile,
               Mask,
               FMask    : String[80];
               Hist     : Array[0..15] of String[78];
               MX, MY   : Word;
               HN,
               CurD,
               Sort     : Byte;
               CO,
               ShowHidden,
               MouseReversed  : Boolean
  End;

Var
  Opt   : OptRec;
  Snow, Mono, Herc,
  Mouse, EDitMenu,
  OverAll : Boolean;
  MB, MX1, MY1, MB1 : Word;
  Less  : LessFunc;
  PS    : ^String;
  WH, WC, WS, WOH,
  I, J, N,
  MN, HP,
  Up, Dn,
  Cur   : Byte;
  Menu  : Array [0..19] of String;
  Buf   : ^Buffer;
  Vid,
  Scr   : ^VBuffer;
  Path  : Array [0..1] of String;
  Dir   : Array [0..1] of DirList;
  Count : Array [0..1] of Word;
  WinF  : Array [0..1] of Word;
  WinS  : Array [0..1] of Word;
  Free  : Array [0..1] of LongInt;
  P, CS, MF, S      : String;
  FDA   : Array [1..100] of String[64];
  FNA   : ^FRA absolute Buf;
  FDC   : Byte;
  FNC   : Word;
{ * Name of File, where encountered any I/O problem * }
  IOErrorFile : String;
{ * Input/Output Error Variable * }
  IOError  : Integer;

{ Configuration }
Procedure LoadCFG (Var Opt : OptRec);
Procedure SaveCFG (Var Opt : OptRec; Z : Boolean);
Procedure LoadTMP (Var Opt : OptRec);
Procedure SaveTMP (Var Opt : OptRec);
Procedure MakeCFG;
Procedure SaveSetup;

{ Funcs & Procs for TextOut }
Procedure SaveScr (Var Buf);
Procedure LoadScr (Var Buf);
{Procedure Color (B, T : Byte);}
Procedure Window (X, Y, L, H : Byte; Name : String; B, T : Byte);
{Function UpStr (S : String) : String;}
Procedure ManWin (Dir : String; X : Byte);
Procedure WinFil;
Procedure ShowSels;
Procedure ErrorMessage;
Procedure CurOff;
Procedure CurOn;

{ Find & Sort Funcs & Procs }
Procedure FreeList;
Procedure FindFiles;
Function DF_EN (Path : PathStr; D : Boolean) : String;
Function LessExtName (X, Y : DirRec) : Boolean;
Function LessSize (X, Y : DirRec) : Boolean;
Function LessName (X, Y : DirRec) : Boolean;
Function LessTime (X, Y : DirRec) : Boolean;
Procedure QuickSort (L, R : Integer);
Procedure SortFiles;
Procedure SortByExtName;
Procedure SortBySize;
Procedure SortByName;
Procedure SortByTime;

{ Other Funcs & Procs }
Function DReadKey : Char;
Function DKeyPressed : Boolean;
{Function CD (P : PathStr) : Boolean;}
Function DirSize (P : Byte) : LongInt;
Procedure FullDir (Dir:String; Var SubDirs,Files:Word; Var Size:LongInt);
Function SelNum (CD : Byte) : Word;
Function SelSize (CD : Byte) : LongInt;
{Function FN (Name : String; Dir : Boolean) : String;}
Function FindName (Name : String) : Word;
{Function FDN (D : String) : String;}
{Function Last (D : String) : String;}
Procedure DSel (D : Byte);
Function Hist : Boolean;
Function NoCom (S : String) : Boolean;
Procedure Posit (S : String);
{Function Exists (Name : PathStr) : Boolean;}
Procedure SaveScreen;
Procedure Timer;
{Function ReadScan : Byte;}
Procedure UnderMouse (Var S : String; Var D : Byte);
Function MousePressed : Boolean;
Procedure MenuInit;
Function MenuS : Boolean;
Function EE (S : String) : String;
Function ES (Ext : String) : String;
{Function CMask (Mask, Name : String) : Boolean;}
Procedure Options;
{Function Contain (Name, Str : String) : Boolean;}
Procedure Memory;
Procedure FExt;

{ File Funcs & Procs }
Procedure FileCopy;
Procedure FileMove;
Procedure FileDelete;
Procedure FileRename;
Procedure MakeDir;
Procedure DeleteDir;
Procedure InvertGroup;
Procedure Search;
Procedure Select;
Procedure DeSelect;
Procedure DirView;
Procedure ComparePanels;
Procedure DirCopy;
Procedure DirMove;
Procedure SaveSelList;
Procedure RestoreSelList;
Procedure FilePrint;
Procedure FileFind;
Function FindView : Byte;

Implementation

Function DReadKey : Char;
Var
  R : Registers;
Begin
  Intr ($28, R);
  DReadKey := CRT.ReadKey
End;

Function DKeyPressed : Boolean;
Var
  R : Registers;
Begin
  Intr ($28, R);
  DKeyPressed := CRT.KeyPressed
End;

Procedure LoadCFG (Var Opt : OptRec);
Var F : File of OptRec;
Begin
  IOError := ReadError;
  IOErrorFile := P+CFG;
  Assign (F, P+CFG);
  {$I-} Reset (F); {$I+}
  If IOResult <> 0 then Exit;
  {$I-} Read (F, Opt); {$I+}
  If IOResult <> 0 then Exit;
  Close (F);
  IOError := Ok
End;

Procedure SaveCFG (Var Opt : OptRec; Z : Boolean);
Var
  F : File of OptRec;
  B : Byte;
Begin
  B := Opt.HN;
  If Z then
    Begin
      Opt.LDir := Path[0];
      Opt.RDir := Path[1];
      Opt.HN   := 0
    End;
  IOError := WriteError;
  IOErrorFile := P+CFG;
  Assign (F, P+CFG);
  {$I-} Rewrite (F); {$I+}
  If IOResult <> 0 then Exit;
  {$I-} Write (F, Opt); {$I+}
  If IOResult <> 0 then Exit;
  Close (F);
  IOError := Ok;
  If Z then Opt.HN := B
End;

Procedure LoadTMP (Var Opt : OptRec);
Var F : File of OptRec;
Begin
  IOError := ReadError;
  IOErrorFile := P+TMP;
  Assign (F, P+TMP);
  {$I-} Reset (F); {$I+}
  If IOResult <> 0 then Exit;
  {$I-} Read (F, Opt); {$I+}
  If IOResult <> 0 then Exit;
  Close (F);
  IOError := Ok
End;

Procedure SaveTMP (Var Opt : OptRec);
Var F : File of OptRec;
Begin
  IOError := WriteError;
  IOErrorFile := P+TMP;
  Opt.LDir := Path[0];
  Opt.RDir := Path[1];
  Assign (F, P+TMP);
  {$I-} Rewrite (F); {$I+}
  If IOResult <> 0 then Exit;
  {$I-} Write (F, Opt); {$I+}
  If IOResult <> 0 then Exit;
  Close (F);
  IOError := Ok
End;

Procedure MakeCFG;
Var F : File of OptRec;
Begin
  With Opt do
    Begin
      LDir := 'C:\'; RDir := 'D:\';
      ExView1 := ''; ExView2 := ''; ExEdit1 := '';
      LFile := ''; RFile := '';
      Mask  := '*.*'; FMask := '*.*';
      HN := 0;
      Sort := 1;
      CurD := 0;
      CO := False;
      ShowHidden := False;
      MouseReversed := False;
    End;
  IOError := WriteError;
  IOErrorFile := P+CFG;
  Assign (F, P+CFG);
  {$I-} Rewrite (F); {$I+}
  If IOResult <> 0 then Exit;
  {$I-} Write (F, Opt); {$I+}
  If IOResult <> 0 then Exit;
  Close (F);
  IOError := Ok
End;

Procedure SaveScr (Var Buf);
Begin
  If Mouse then MouseHide;
  Move (GetScreenPtr^, Buf, 8000);
  If Mouse then MouseShow
End;

Procedure LoadScr (Var Buf);
Begin
  If Mouse then MouseHide;
  Move (Buf, GetScreenPtr^, 8000);
  If Mouse then MouseShow
End;

Procedure Window (X, Y, L, H : Byte; Name : String; B, T : Byte);
Var
  Min, Max : Word;
  I, J : Byte;
Begin
  If Mouse then MouseHide;
  Color (B, T);
  Min := WindMin;
  Max := WindMax;
  CRT.Window (X, Y, X+L-1, Y+H-1);
  ClrScr;
  CRT.Window (Lo(Min)+1, Hi(Min)+1, Lo(Max)+1, Hi(Max)+1);
  GotoXY (X+2, Y+1); Write ('');
  GotoXY (X+2, Y+H-2); Write ('');
  GotoXY (X+L-3, Y+1); Write ('');
  GotoXY (X+L-3, Y+H-2); Write ('');
  For I := X+3 to X+L-4 do
    Begin
      GotoXY (I, Y+1); Write ('');
      GotoXY (I, Y+H-2); Write ('')
    End;
  For J := Y+2 to Y+H-3 do
    Begin
      GotoXY (X+2, J); Write ('');
      GotoXY (X+L-3, J); Write ('')
    End;
  GotoXY (X+(L-Length(Name)) div 2-1, Y+1);
  Write (' '+Name+' ');
  Color (Black, Black);
  For J := Y+1 to Y+H do
    Begin
      GotoXY (X+L, J);
      Write ('')
    End;
  For I := X+2 to X+L do
    Begin
      GotoXY (I, Y+H);
      Write ('')
    End;
  Color (B, T);
  If Mouse then MouseShow
End;

Function DirSize (P : Byte) : LongInt;
Var
  N : Word;
  S : LongInt;
Begin
  S := 0;
  If Count[P] > 0 then
    For N := 0 to Count[P]-1 do
      If Dir[P][N].Attr and Directory = 0 then
        Inc (S, Dir[P][N].Size);
  DirSize := S
End;

Procedure FullDir (Dir:String; Var SubDirs,Files:Word; Var Size:LongInt);
Var
  R : Registers;
  S : SearchRec;
Begin
  If Dir[Length (Dir)] <> '\' then Dir := Dir+'\';
  FindFirst (Dir+'*.*', AnyFile-VolumeID, S);
  While DOSError = 0 do
    Begin
      If S.Attr and Directory = 0 then
        Begin
          Inc (Files);
          Inc (Size, S.Size)
        End;
      FindNext (S)
    End;
  FindFirst (Dir+'*.*', AnyFile-VolumeID, S);
  While DOSError = 0 do
    Begin
      If (S.Attr and Directory = Directory) and
         (S.Name[1] <> '.') then
         Begin
           FullDir (Dir+S.Name, SubDirs, Files, Size);
           Inc (SubDirs);
           R.AH := $1A;
           R.DS := Seg (S);
           R.DX := Ofs (S);
           MSDOS (R)
         End;
      FindNext (S)
    End
End;

Function SelNum (CD : Byte) : Word;
Var
  I,
  N : Word;
Begin
  N := 0;
  If Count [CD] <> 0 then
    For I := 0 to Count[CD]-1 do
      If Dir[CD][I].Sel then Inc (N);
  SelNum := N
End;

Function SelSize (CD : Byte) : LongInt;
Var
  I : Word;
  S : LongInt;
Begin
  S := 0;
  If Count [CD] <> 0 then
    For I := 0 to Count[CD]-1 do
      If Dir[CD][I].Sel then Inc (S, Dir[CD][I].Size);
  SelSize := S
End;

Procedure ManWin (Dir : String; X : Byte);
Var
  I, J : Byte;
Begin
  If Mouse then MouseHide;
  CursorOff;
  Color (Blue, LightCyan);
  GotoXY (X, 1); Write ('');
  For I := X+1 to X+38 do
    Begin
      GotoXY (I, WH-1); Write ('');
      GotoXY (I, WH-5); Write ('');
      GotoXY (I, 1);  Write ('')
    End;
  Write ('');
  For I := 2 to WH-2 do
    Begin
      GotoXY (X, I);    Write ('');
      GotoXY (X+39, I); Write ('')
    End;
  GotoXY (X, WH-1);   Write ('');
  GotoXY (X+39,WH-1); Write ('');
  For I := 2 to WC+1 do
    Begin
      GotoXY (X+13, I); Write ('');
      GotoXY (X+26, I); Write ('')
    End;
  If Length (Dir) > 21 then
    Dir := Copy(Dir,1,9)+'...'+Copy(Dir,Length(Dir)-8,9);
  GotoXY ( (40-Length(Dir)) div 2 + X - 1, 1); Write (' '+Dir+' ');
  If Mouse then MouseShow
End;

Procedure Timer;
Var
  Segment, Offset,
  H, M, S, S100 : Word;
  St, Strn : String;
Begin
  If Snow then Exit;
  GetTime (H, M, S, S100);
  Str (H:2, St);
  Strn := St+':';
  Str (M, St);
  If Length (St) = 1 then St := '0'+St;
  Strn := Strn+St+':';
  Str (S, St);
  If Length (St) = 1 then St := '0'+St;
  Strn := Strn+St;
  Segment := Seg (GetScreenPtr^);
  Offset := Ofs (GetScreenPtr^);
  Inc (Offset, 72*2);
  For M := 1 to 8 do
    Begin
      Mem[Segment:Offset] := Ord (Strn[M]);
      Inc (Offset);
      If Segment = $B000 then
        Mem[Segment:Offset] := LightGray*16+Black
      Else
        Mem[Segment:Offset] := LightGray*16+Blue;
      Inc (Offset)
    End
End;

Procedure Posit (S : String);
Var
  N : Word;
Begin
  N := FindName (S);
  If N < WS then
    Begin
      WinF[Opt.CurD] := 0;
      WinS[Opt.CurD] := N
    End
  Else
    If N >= Count[Opt.CurD]-WS then
      Begin
        WinF[Opt.CurD] := Count[Opt.CurD]-WS;
        WinS[Opt.CurD] := WS-Count[Opt.CurD]+N
      End
  Else
    Begin
      WinF[Opt.CurD] := N;
      WinS[Opt.CurD] := 0
    End
End;

Function DF_EN (Path : PathStr; D : Boolean) : String;
Var
  Dir  : DirStr;
  Name : NameStr;
  Ext  : ExtStr;
  S    : String;
Begin
  FSplit (Path, Dir, Name, Ext);
  S := Ext;
  While Length (S) < 4 do S := S + ' ';
  S := S + Name;
  If D then S := '0' + S
  Else
    Begin
      If Ext = '.BAT' then S := '1'+S;
      If Ext = '.COM' then S := '2'+S;
      If Ext = '.EXE' then S := '3'+S;
      If (Ext <> '.BAT') and (Ext <> '.COM') and (Ext <> '.EXE') then
        S := '4'+S
    End;
  If Path = '..' then S := '';
  DF_EN := S
End;

{$F+}

Function LessExtName (X, Y : DirRec) : Boolean;
Begin
  LessExtName := DF_EN (X.Name, X.Attr and Directory <> 0) <
                 DF_EN (Y.Name, Y.Attr and Directory <> 0)
End;

{$F-}

Function DF_SZ (Path : PathStr; Sz : LongInt; D : Boolean) : String;
Var
  Dir  : DirStr;
  Name : NameStr;
  Ext  : ExtStr;
  S    : String;
Begin
  FSplit (Path, Dir, Name, Ext);
  Str (Sz, S);
  While Length (S) < 10 do S := ' '+S;
  S := S + Ext;
  While Length (S) < 14 do S := S+' ';
  S := S + Name;
  If D then S := '0'+S
  Else
    S := '1'+S;
  If Path = '..' then S := '';
  DF_SZ := S
End;

{$F+}

Function LessSize (X, Y : DirRec) : Boolean;
Begin
  LessSize := DF_SZ (X.Name, X.Size, X.Attr and Directory <> 0) <
                 DF_SZ (Y.Name, Y.Size, Y.Attr and Directory <> 0)
End;

{$F-}

Function DF_N (Path : PathStr; D : Boolean) : String;
Var
  Dir  : DirStr;
  Name : NameStr;
  Ext  : ExtStr;
  S    : String;
Begin
  S := Path;
  If D then S := '0'+S
  Else
    S := '1'+S;
  If Path = '..' then S := '';
  DF_N := S
End;

{$F+}

Function LessName (X, Y : DirRec) : Boolean;
Begin
  LessName := DF_N (X.Name, X.Attr and Directory <> 0) <
                 DF_N (Y.Name, Y.Attr and Directory <> 0)
End;

{$F-}

Function DF_T (Path : PathStr; Tm : LongInt; D : Boolean) : String;
Var
  Dir  : DirStr;
  Name : NameStr;
  Ext  : ExtStr;
  T,
  S    : String;
  DT   : DateTime;
Begin
  FSplit (Path, Dir, Name, Ext);
  S := Ext;
  While Length (S) < 4 do S := S + ' ';
  S := S + Name;
  UnPackTime (Tm, DT);
  Str (DT.Sec:4, T);
  S := T+S;
  Str (DT.Min:4, T);
  S := T+S;
  Str (DT.Hour:4, T);
  S := T+S;
  Str (DT.Day:4, T);
  S := T+S;
  Str (DT.Month:4, T);
  S := T+S;
  Str (DT.Year:4, T);
  S := T+S;
  If D then S := '0'+S
  Else
    S := '1'+S;
  If Path = '..' then S := '';
  DF_T := S
End;

{$F+}

Function LessTime (X, Y : DirRec) : Boolean;
Begin
  LessTime := DF_T (X.Name, X.Time, X.Attr and Directory <> 0) <
                 DF_T (Y.Name, Y.Time, Y.Attr and Directory <> 0)
End;

{$F-}

Procedure QuickSort (L, R : Integer);
Var
  I, J : Integer;
  X, Y : DirRec;
Begin
  I := L;
  J := R;
  X := Dir[Opt.CurD][(L + R) div 2];
  Repeat
    While Less (Dir[Opt.CurD][I], X) do Inc(I);
    While Less (X, Dir[Opt.CurD][J]) do Dec(J);
    If I <= J then
      Begin
        Y := Dir[Opt.CurD][I];
        Dir[Opt.CurD][I] := Dir[Opt.CurD][J];
        Dir[Opt.CurD][J] := Y;
        Inc(I);
        Dec(J)
    End;
  Until I > J;
  If L < J then QuickSort (L, J);
  If I < R then QuickSort (I, R);
End;

Procedure FindFiles;
Var
  I : Boolean;
  F : SearchRec;
Label
  L;
Begin
  I := True;
  Free[Opt.CurD] := DiskFree (Ord (Path[Opt.CurD][1]) - Ord('A') + 1);
  While Free[Opt.CurD] = -1 do DSel (Opt.CurD);
  Count[Opt.CurD] := 0;
  FindFirst (Path[Opt.CurD]+'*.*', AnyFile-VolumeID, F);
  While (DosError = 0) and (Count[Opt.CurD] < MaxDirSize) do
    Begin
      If F.Attr and VolumeID <> 0 then Goto L;
      If (F.Attr and (Hidden+SysFile) <> 0) and not Opt.ShowHidden then
        Goto L;
      If F.Name = '.' then Goto L;
      If F.Name = '..' then
        Begin
          I := False;
          If Length (Path[Opt.CurD]) = 3 then Goto L
        End;
      If F.Attr and Directory <> 0 then F.Size := 0;
      Move (F.Attr, Dir[Opt.CurD][Count[Opt.CurD]], SizeOf (DirRec));
      Dir[Opt.CurD][Count[Opt.CurD]].Sel := False;
      Inc (Count[Opt.CurD]);
      L:
      FindNext(F)
    End;
  If (Length (Path[Opt.CurD]) > 3) and I then
    Begin
      F.Name := '..'; F.Attr := Directory; F.Size := 0;
      Move (F.Attr, Dir[Opt.CurD][Count[Opt.CurD]], SizeOf (DirRec));
      Dir[Opt.CurD][Count[Opt.CurD]].Sel := False;
      Inc (Count[Opt.CurD])
    End
End;

Procedure SortFiles;
Begin
  If (Count[Opt.CurD] <> 0) and (@Less <> nil) then
    QuickSort (0, Count[Opt.CurD] - 1);
End;

Function FindName (Name : String) : Word;
Var
  F : Boolean;
  N : Word;
Begin
{  Name := UpStr(Name);}
  F := False;
  N := 0;
  Repeat
      If Dir[Opt.CurD][N].Name = UpStr(Name) then
        Begin
          F := True;
          Break
        End;
      Inc (N)
  Until N = Count[Opt.CurD];
  If F then FindName := N
  Else FindName := 0
End;

Function FindName2 (Name : String) : Word;
Var
  F : Boolean;
  N : Word;
Begin
  F := False;
  N := 0;
  Repeat
    If Dir[1-Opt.CurD][N].Name = UpStr (Name) then
      Begin
        F := True;
        Break
      End;
    Inc (N)
  Until (N >= Count[1-Opt.CurD]);
  If F then FindName2 := N
  Else FindName2 := $FFFF
End;

Procedure CurOff;
Var
  Nm : String[12];
Begin
  N := WinS[Opt.CurD];
  If Mouse then MouseHide;
  CursorOff;
  TextBackGround (Blue);
  If Count[Opt.CurD] <> 0 then
    Begin
      If not Herc then
        If Dir[Opt.CurD][WinF[Opt.CurD]+WinS[Opt.CurD]].Sel then
          TextColor (Yellow)
        Else
          If Mono then TextColor (LightGray)
          Else TextColor (LightCyan);
      If Herc then Color (Blue, LightCyan);
      GotoXY (40*Opt.CurD+2+13*(N div WC), 2+N mod WC);
      Nm := FNH (Dir[Opt.CurD][WinF[Opt.CurD]+N].Name,
                     Dir[Opt.CurD][WinF[Opt.CurD]+N].Attr and Directory <> 0,
                     Dir[Opt.CurD][WinF[Opt.CurD]+N].Attr and Hidden <> 0);
      If Herc and Dir[Opt.CurD][WinF[Opt.CurD]+N].Sel then
        Nm[9] := '';
      Write (Nm)
    End;
  If Mouse then MouseShow
End;

Procedure CurOn;
Var Nm : String[12];
Begin
  N := WinS[Opt.CurD];
  If Mouse then MouseHide;
  CursorOff;
  TextBackGround (Blue);
  If Count[Opt.CurD] <> 0 then
    Begin
      If not Herc then
        If Dir[Opt.CurD][WinF[Opt.CurD]+WinS[Opt.CurD]].Sel then
          Color (LightCyan, Yellow)
        Else
          If Mono then TextColor (LightGray)
          Else TextColor (LightCyan);
      If Herc then Color (Blue, LightCyan);
      GotoXY (40*Opt.CurD+2+13*(N div WC), 2+N mod WC);
      Nm := FNH (Dir[Opt.CurD][WinF[Opt.CurD]+N].Name,
                     Dir[Opt.CurD][WinF[Opt.CurD]+N].Attr and Directory <> 0,
                     Dir[Opt.CurD][WinF[Opt.CurD]+N].Attr and Hidden <> 0);
      If Herc and Dir[Opt.CurD][WinF[Opt.CurD]+N].Sel then
        Nm[9] := '';
      Write (Nm)
    End;
  If Mouse then MouseShow
End;

Procedure WinFil;
Var
  M : Byte;
  Nm : String[12];
Begin
  If Mouse then MouseHide;
  N := 0;
  M := 40*Opt.CurD+2;
  CursorOff;
  TextBackGround (Blue);
  If Count[Opt.CurD] <> 0 then
    While (WinF[Opt.CurD] + N < Count[Opt.CurD]) and (N < WS) do
      Begin
        If not Herc then
          If Dir[Opt.CurD][WinF[Opt.CurD]+N].Sel then
            TextColor (Yellow)
          Else
            If Mono then TextColor (LightGray)
            Else TextColor (LightCyan);
        If Herc then
          Color (Blue, LightCyan);
        GotoXY (M+13*(N div WC), 2+N mod WC);
        Nm := FNH (Dir[Opt.CurD][WinF[Opt.CurD]+N].Name,
                     Dir[Opt.CurD][WinF[Opt.CurD]+N].Attr and Directory <> 0,
                     Dir[Opt.CurD][WinF[Opt.CurD]+N].Attr and Hidden <> 0);
        If Herc and Dir[Opt.CurD][WinF[Opt.CurD]+N].Sel then
          Nm[9] := '';
        Write (Nm);
        Inc (N)
      End;
  If Count[Opt.CurD] = 0 then N := 0;
  Color (Blue, LightCyan);
  For M := N to WS-1 do
    Begin
      GotoXY (40*Opt.CurD+2+13*(M div WC), 2+M mod WC);
      Write ('':12)
    End;
  If Mouse then MouseShow
End;

Procedure ShowSels;
Const
  SubDir = ' '#16'SUB-DIR'#17' ';
Var
  I, J : Byte;
  S : String;
  T : DateTime;
  Nm: String[12];
Procedure Writ (S : String);
Var B : Byte;
Begin
  For B := 1 to Length (S) do
    If S[B]<>'=' then Write (S[B])
    Else GotoXY (WhereX+1, WhereY)
End;
Begin
  If Mouse then MouseHide;
  CursorOff;
  For N := 0 to 1 do
    Begin
      Color (Blue, Yellow);
      GotoXY (2+N*40, WH-3);
      If SelNum(N) <> 0 then
        Begin
          S := LongStr (SelSize(N),1);
          S := S+'Bytes selected in '+LongStr2(SelNum(N))+' file';
          If SelNum(N) > 1 then S := S+'s';
          While Length (S) < 37 do
            S := ' '+S+' ';
          If Length (S) = 37 then S := S+' ';
          Write (S)
        End
      Else
        Write ('          No files selected           ');
      {File Info}
      Color (Blue, LightCyan);
      GotoXY (N*40+2,WH-4);
      If Count[N] <> 0 then
        Begin
          Write (FN (Dir[N][WinF[N]+WinS[N]].Name,
                  Dir[N][WinF[N]+WinS[N]].Attr and Directory <> 0));
          If Dir[N][WinF[N]+WinS[N]].Attr and Directory <> 0 then
            Begin
              If Dir[N][WinF[N]+WinS[N]].Name <> '..' then
                Write (SubDir)
              Else
                Begin
                  S := LongStr (DirSize(N),11);
                  If S[Length(S)] = ' ' then Write (' '+Copy (S, 1, Length(S)-1))
                  Else Write (S)
                End
            End
          Else
            Begin
              S := LongStr (Dir[N][WinF[N]+WinS[N]].Size,11);
              If S[Length(S)] = ' ' then Write (' '+Copy (S, 1, Length(S)-1))
              Else Write (S)
            End;
          {Time & Date}
          UnPackTime (Dir[N][WinF[N]+WinS[N]].Time, T);
          Write (' ');
          Write (T.Day:2, '-');
          If T.Month < 10 then Write ('0');
          Write (T.Month, '-');
          T.Year := T.Year mod 100;
          If T.Year < 10 then Write ('0'); Write (T.Year, ' ');
          Write (T.Hour:2, ':');
          If T.Min < 10 then Write ('0');
          Write (T.Min) End
          Else Write ('':38);
          {Path}
          If N = Opt.CurD then
            Color (LightCyan, Black)
          Else
            Color (Blue, LightCyan);
          If Length (Path[N]) < 22 then
            Begin
              GotoXY ( (40-Length(Path[N])) div 2 + 40*(N), 1);
              Write (' '+Path[N]+' ');
            End
          Else
            Begin
              GotoXY ( (40-21) div 2 + 40*(N), 1);
              Write
              (' '+Copy(Path[N],1,9)+'...'+Copy(Path[N],Length(Path[N])-8,9)+' ')
            End;
          {File at Cursor}
          GotoXY (40*N+2+13*(WinS[N] div WC), 2+WinS[N] mod WC);
          If Count[N] <> 0 then
            Begin
          If N = Opt.CurD then
            Begin
              If Dir[N][WinF[N]+WinS[N]].Sel then
                Color (LightCyan, Yellow)
              Else
                Color (LightCyan, Black);
              If Herc then Color (LightCyan, Black);
              Nm := FNH (Dir[N][WinF[N]+WinS[N]].Name,
                  Dir[N][WinF[N]+WinS[N]].Attr and Directory <> 0,
                  Dir[N][WinF[N]+WinS[N]].Attr and Hidden <> 0);
              If Herc and Dir[N][WinF[N]+WinS[N]].Sel then Nm[9] := '';
              Write (Nm)
            End
          Else
            Begin
              If not Herc then
                If Dir[N][WinF[N]+WinS[N]].Sel then
                  Color (Blue, Yellow)
                Else
                  If Mono then Color (Blue, LightGray)
                  Else Color (Blue, LightCyan);
              If Herc then Color (Blue, LightCyan);
              Nm := FNH (Dir[N][WinF[N]+WinS[N]].Name,
                  Dir[N][WinF[N]+WinS[N]].Attr and Directory <> 0,
                  Dir[N][WinF[N]+WinS[N]].Attr and Hidden <> 0);
              If Herc and Dir[N][WinF[N]+WinS[N]].Sel then Nm[9] := '';
              Write (Nm)
            End;
        End;
      {Free}
      GotoXY (2+N*40, WH-2);
      Color (Blue, LightGray);
      S := 'Free : '+LongStr2 (Free[N])+' Bytes';
      While Length (S) < 37 do
        S := ' '+S+' ';
      If Length (S) = 37 then S := S+' ';
      Write (S);
      While WhereX < N*40+40 do Write (' ')
    End;
  If Mouse then
    Begin
      Color (Blue, Green);
      GotoXY (6,WH-5);  Write ('[-'#24'-]');
      GotoXY (31,WH-5); Write ('[-'#25'-]');
      GotoXY (46,WH-5); Write ('[-'#24'-]');
      GotoXY (71,WH-5); Write ('[-'#25'-]');
      GotoXY (2, WH-1);
      Writ ('[Menu]=[Hist]=[View]=[Edit]=[Copy]=[R/M]=[MD]=[Del]=[Comp]=[Mem]=[LPT1]=[Quit]');
      MouseShow
    End;
  Color (Blue, LightCyan)
End;

Procedure FreeList;
Begin
  WinF[Opt.CurD] := 0;
  WinS[Opt.CurD] := 0
End;

Procedure DSel (D : Byte);
Var
  I, J : Byte;
  C    : Char;
  S    : String;
Label
  L;

  Procedure WD;
  Var I : Byte;
  Begin
    If Mouse then MouseHide;
    For I := 1 to Length (DOSDrives) do
      Begin
        GotoXY (D*40+18, 5+I);
        If J = I then Color (Green, Black)
        Else Color (LightGray, Red);
        Write ('  '+Copy (DOSDrives, I, 1)+':  ')
      End;
    If Mouse then MouseShow
  End;

Begin
  If Mouse then
    While MousePressed do;
  CursorOff;
  Color (LightGray, Black);
  Window (D*40+13, 4, 16, 4+Length (DOSDrives), 'Drive:', LightGray, Black);
  J := Pos (Copy (Path[D], 1, 1), DOSDrives);
  WD;
  C := #$FF;
  While true do
    Begin
      Timer;
      If DKeyPressed then C := UpCase (DReadKey)
      Else C := #$FF;
      If Mouse then
        Begin
          MouseReadText (Opt.MX, Opt.MY, MB);
          If (MB and 1 = 1) and ((Opt.MX-40*D < 13) or
          (Opt.MX-40*D > 28) or (Opt.MY < 4) or
          (Opt.MY > 4 + Length (DOSDrives) + 3)) then C := #27;
          If (MB and 1 = 1) and (Opt.MX-40*D in [18..23]) and
          (Opt.MY in [6..5+Length(DosDrives)]) then
            Begin
              J := Opt.MY-5;
              C := #13
            End
        End;
      If Pos (C, DOSDrives) <> 0 then
        Begin
          J := Pos (C, DOSDrives);
          C := #13
        End;
      If C = #13 then
        Begin
          Opt.CurD := D;
          ManWin (Path[Opt.CurD], Opt.CurD*40+1);
          WinFil;
          Opt.CurD := 1-Opt.CurD;
          ManWin (Path[Opt.CurD], Opt.CurD*40+1);
          WinFil;
          Opt.CurD := 1-Opt.CurD;
          S := Copy (DOSDrives, J, 1) + ':\';
          If not CD (S) then Goto L;
          Path[D] := S;
          FreeList;
          FindFiles;
          ShowSels;
          SortFiles;
          L:
          ManWin (Path[Opt.CurD], Opt.CurD*40+1);
          WinFil;
          Opt.CurD := 1-Opt.CurD;
          ManWin (Path[Opt.CurD], Opt.CurD*40+1);
          WinFil;
          Opt.CurD := 1-Opt.CurD;
          If Mouse then
            While MousePressed do;
          Exit
        End;
      If C = #27 then Goto L;
      If C = #32 then
        Begin
          If J < Length (DOSDrives) then Inc (J)
          Else J := 1;
          WD
        End;
      If C = #0 then
        Begin
          C := DReadKey;
          Case C of
            #72 : If J > 1 then Dec (J);
            #80 : If J < Length (DOSDrives) then Inc (J)
          End;
          WD
        End
    End
End;

Function Hist: Boolean;
Var
  P    : Boolean;
  C    : Char;
  I, J : Byte;

Label
  L;

  Procedure Show (Z : Byte; B : Boolean);
  Begin
    If Mouse then MouseHide;
      Begin
        GotoXY (14, 5+Z);
        If B then Color (Black, White)
        Else Color (Cyan, Black);
        If Length (Opt.Hist[Z]) < 55 then
          Write (Opt.Hist[Z])
        Else
          Begin
            Write (Copy (Opt.Hist[Z], 1, 53));
            TextColor (Yellow);
            Write ('')
          End;
        While WhereX < 68 do Write (' ')
      End;
    If Mouse then MouseShow
  End;

Begin
  If Mouse then
    While MousePressed do;
  CursorOff;
  P := False;
  If Opt.HN = 0 then Goto L;
  Color (LightCyan, Black);
  Window (11, 3, 60, 20, 'History', LightCyan, White);
  For I := 0 to Opt.HN-1 do Show (I, false);
  Show (HP, true);
  C := #$FF;
  While true do
    Begin
      Timer;
      If DKeyPressed then C := DReadKey
      Else C := #$FF;
      If Mouse then
        Begin
          MouseReadText (Opt.MX, Opt.MY, MB);
          If (MB and 1 = 1) and
            ((Opt.MX < 11) or (Opt.MX > 70) or
             (Opt.MY < 3) or (Opt.MY > 22)) then Break;
          If (MB and 1 = 1) and (Opt.MX >= 14) and (Opt.MX <= 67) and
            (Opt.MY-5 <= Opt.HN-1) then
              Begin
                HP := Opt.MY-5;
                C := #13
              End
        End;
      If C = #27 then Break;
      If C = #13 then
        Begin
          P := True;
          Break
        End;
      If C = #0 then
        Begin
          C := DReadKey;
          Case C of
            #72 : {UP}
              If HP > 0 then
                Begin
                  Show (HP, false);
                  Dec (HP);
                  Show (HP, true)
                End;
            #80 : {Down}
              If HP < Opt.HN-1 then
                Begin
                  Show (HP, false);
                  Inc (HP);
                  Show (HP, true)
                End;
            #71,  {Home}
            #73 : {PgUp}
              If HP > 0 then
                Begin
                  Show (HP, false);
                  HP := 0;
                  Show (HP, true)
                End;
            #79,  {End}
            #81 : {PgDn}
              If HP < Opt.HN-1 then
                Begin
                  Show (HP, false);
                  HP := Opt.HN-1;
                  Show (HP, true)
                End
          End
        End
    End;
  CursorOn (Up, Dn);
L:
  If Mouse then
    While MousePressed do;
  Hist := P
End;

Function NoCom (S : String) : Boolean;
Var
  P : Boolean;
Label L;
Begin
  P := True;
  If Opt.HN = 0 then Goto L;
  If Opt.Hist[Opt.HN-1] = S then P := False;
L:
  NoCom := P
End;

Procedure OneDir;
Var
  N : Word;
Begin
  Count[1-Opt.CurD] := Count[Opt.CurD];
  If Count[0] > 0 then
  For N := 0 to Count[0]-1 do
    Dir[1-Opt.CurD][N] := Dir[Opt.CurD][N]
End;

Function OverWrite (Name : String) : Boolean;
Var
  C : Char;
  I : Byte;
Label L;
Begin
  If OverAll then
    Begin
      I := 1;
      Goto L
    End;
  If Mouse then MouseHide;
  GotoXY (27, 12);
  Write (Name+' already exists.');
  GotoXY (27, 13);
  Write ('Overwrite ?');
  I := 1;
  GotoXY (30, 14);
  If I = 1 then Color (LightCyan, Black)
  Else Color (LightGray, Black);
  Write ('[ Yes ]');
  GotoXY (38, 14);
  If I = 2 then Color (LightCyan, Black)
  Else Color (LightGray, Black);
  Write ('[ All ]');
  GotoXY (46, 14);
  If I = 3 then Color (LightCyan, Black)
  Else Color (LightGray, Black);
  Write ('[ No ]');
  If Mouse then MouseShow;
  Repeat
    Timer;
    If DKeyPressed then C := UpCase (DReadKey)
    Else C := #$FF;
    If Mouse then
      Begin
        MouseReadText (Opt.MX, Opt.MY, MB);
        If (MB and 1 = 1) and (Opt.MY = 14) and (Opt.MX in [30..36]) then
          C := 'Y';
        If (MB and 1 = 1) and (Opt.MY = 14) and (Opt.MX in [38..44]) then
          C := 'A';
        If (MB and 1 = 1) and (Opt.MY = 14) and (Opt.MX in [46..51]) then
          C := 'N'
      End;
    If C = 'Y' then I := 1;
    If C = 'A' then I := 2;
    If C = 'N' then I := 3;
    If C in ['N', 'Y', 'A', #13] then Break;
    If C = #0 then
      Begin
        C := DReadKey;
        Case C of
          #77 : If I < 3 then Inc (I);
          #75 : If I > 1 then Dec (I)
        End;
        GotoXY (30, 14);
        If I = 1 then Color (LightCyan, Black)
        Else Color (LightGray, Black);
        Write ('[ Yes ]');
        GotoXY (38, 14);
        If I = 2 then Color (LightCyan, Black)
        Else Color (LightGray, Black);
        Write ('[ All ]');
        GotoXY (46, 14);
        If I = 3 then Color (LightCyan, Black)
        Else Color (LightGray, Black);
        Write ('[ No ]')
      End;
  Until False;
  Color (LightGray, Black);
  GotoXY (27, 12);
  Write (' ':28);
  GotoXY (27, 13);
  Write (' ':28);
  GotoXY (27, 14);
  Write (' ':28);
L:
  If I = 2 then
    Begin
      I := 1;
      OverAll := True
    End;
  OverWrite := I = 1
End;

Procedure CopyFile (Source, Target, Name : String;
                    FullSize : LongInt; Var Copied : LongInt);
Var
  K, M    : Byte;
  F1, F2  : File;
  S,
  Time    : LongInt;
  Attr,
  NumRead, NumWritten : Word;
Begin
  FileMode := 0;
  Assign (F1, Source+Name);
  {$I-}
  Reset (F1, 1);
  {$I+}
  If IOResult <> 0 then
    Begin
      IOErrorFile := Source+Name;
      IOError := ReadError;
      Exit
    End;
  If Exists (Target+Name) then
    Begin
      Assign (F2, Target+Name);
      {$I-}
      SetFAttr (F2, Archive);
      {$I+}
      If IOResult <> 0 then
        Begin
          Close (F1);
          IOError := WriteError;
          IOErrorFile := Target+Name;
          Exit
        End;
      {$I-}
      Erase (F2);
      {$I+}
      If IOResult <> 0 then
        Begin
          Close (F1);
          IOError := DeleteError;
          IOErrorFile := Target+Name;
          Exit
        End
    End;
  If DiskFree (DiskNum (Target[1])) < FileSize (F1) then
    Begin
      Close (F1);
      IOErrorFile := Target+Name;
      IOError := NoSpace;
      Exit
    End;
  FileMode := 2;
  Assign (F2, Target+Name);
  {$I-}
  Rewrite (F2, 1);
  {$I+}
  If IOResult <> 0 then
    Begin
      Close (F1);
      IOErrorFile := Target+Name;
      IOError := WriteError;
      Exit
    End;
  Repeat
    Timer;
    {$I-}
    BlockRead (F1, Buf^, SizeOf (Buffer), NumRead);
    {$I+}
    If IOResult <> 0 then
      Begin
        Close (F2);
        IOErrorFile := Source+Name;
        IOError := ReadError;
        Exit
      End;
    {$I-}
    BlockWrite (F2, Buf^, NumRead, NumWritten);
    {$I+}
    If IOResult <> 0 then
      Begin
        Close (F1);
        IOErrorFile := Target+Name;
        IOError := WriteError;
        Exit
      End;
    Inc (Copied, NumRead);
    If FullSize = 0 then M := 0
    Else M := Round (Copied/FullSize*20);
    GotoXY (30, 11);
    For K := 1 to M do Write ('');
  Until (NumRead = 0) or (NumWritten <> NumRead);
  GetFTime (F1, Time);
  SetFTime (F2, Time);
  If FileSize (F2) <> FileSize (F1) then
    Begin
      Close (F1);
      Close (F2);
      IOErrorFile := Target+Name;
      IOError := WriteError;
      Exit
    End;
  Close (F1);
  Close (F2);
  GetFAttr (F1, Attr);
  SetFAttr (F2, Attr)
End;

Procedure FileCopy;
Var
  C : Char;
  I, J : Byte;
  P, F : Boolean;
  S, AS: LongInt;
  NumRead, NumWritten,
  K, M, N : Word;
  F1, F2 : File;

  Function CFC : Boolean;
  Var
    C : Char;
    I, J : Byte;
  Begin
    If Mouse then MouseHide;
    Window (4, 9, 74, 7, 'Copy', LightGray, Black);
    GotoXY (8, 11);
    If SelNum (Opt.CurD) = 0 then Dir[Opt.CurD][WinS[Opt.CurD]+WinF[Opt.CurD]].Sel := True;
    Write ('Copy ', SelNum(Opt.CurD), ' file(s) to');
    GotoXY (8, 12);
    Write (Path[1-Opt.CurD]);
    I := 1;
    GotoXY (30, 13);
    If I = 1 then Color (LightCyan, Black)
    Else Color (LightGray, Black);
      Write (BCopy);
    GotoXY (44, 13);
    If I = 2 then Color (LightCyan, Black)
    Else Color (LightGray, Black);
      Write (BCancel);
    If Mouse then MouseShow;
    While true do
      Begin
        Timer;
        If DKeyPressed then C := DReadKey
        Else C := #$FF;
        If Mouse then
          Begin
            MouseReadText (Opt.MX, Opt.MY, MB);
            If (MB and 1 = 1) and (Opt.MY = 13) and (Opt.MX in [30..37]) then
              Begin
                I := 1;
                C := #13
              End;
            If (MB and 1 = 1) and (Opt.MY = 13) and (Opt.MX in [44..53]) then
              C := #27
          End;
        If (C = #27) or ((I = 2) and (C = #13)) then
          Begin
            I := 2;
            If (SelNum (Opt.CurD) = 1) and
              (Dir[Opt.CurD][WinS[Opt.CurD]+WinF[Opt.CurD]].Sel = True) then
              Dir[Opt.CurD][WinS[Opt.CurD]+WinF[Opt.CurD]].Sel := False;
            C := #13
          End;
        If C = #13 then Break;
        If C = #0 then
          Begin
            C := DReadKey;
            I := 3-I;
            GotoXY (30, 13);
            If I = 1 then Color (LightCyan, Black)
            Else Color (LightGray, Black);
              Write (BCopy);
            GotoXY (44, 13);
            If I = 2 then Color (LightCyan, Black)
            Else Color (LightGray, Black);
              Write (BCancel);
          End
      End;
    CFC := I = 1
  End;

Begin
  If Path[Opt.CurD] = Path[1-Opt.CurD] then Exit;
  CursorOff;
  SaveScr (Vid^);
  P := CFC;
  If Mouse then
    While MousePressed do;
  LoadScr (Vid^);
  If not P then Exit;
  AS := SelSize (Opt.CurD);
  S := 0;
  Window (23, 9, 36, 8, 'Copying...', LightGray, Black);
  GotoXY (27, 11); Write (Per);
  For N := 0 to Count[Opt.CurD]-1 do
    If Dir[Opt.CurD][N].Sel then
      Begin
        If {Exists (Path[1-CurD]+Dir[CurD][N].Name)}
           FindName2 (Dir[Opt.CurD][N].Name) <> $FFFF then
          Begin
            F := OverWrite (Dir[Opt.CurD][N].Name);
            If not F then
              Begin
                Inc (S, Dir[Opt.CurD][N].Size);
                M := Round (S/AS*20);
                GotoXY (30, 11);
                For K := 1 to M do Write ('');
                Continue
              End
            Else
              Begin
                Opt.CurD := 1-Opt.CurD;
                If Dir[Opt.CurD][FindName(Dir[1-Opt.CurD][N].Name)].Size+
                  Free[Opt.CurD] < Dir[1-Opt.CurD][N].Size then
                  Begin
                    Opt.CurD := 1-Opt.CurD;
                    IOError := NoSpace;
                    IOErrorFile := Path[1-Opt.CurD]+Dir[1-Opt.CurD][N].Name;
                    Break
                  End;
                Opt.CurD := 1-Opt.CurD
              End
          End
        Else
          If (Free [1-Opt.CurD] < Dir[Opt.CurD][N].Size) then
            Begin
              IOError := NoSpace;
              IOErrorFile := Path[1-Opt.CurD]+Dir[Opt.CurD][N].Name;
              Break
            End;
        CopyFile (Path[Opt.CurD], Path[1-Opt.CurD], Dir[Opt.CurD][N].Name, AS, S);
        If IOError <> Ok then
          Break;
        Dir[Opt.CurD][N].Sel := False
      End;
  LoadScr (Vid^);
  WinFil;
  Opt.CurD := 1-Opt.CurD;
  FreeList;
  FindFiles;
  SortFiles;
  If Opt.CurD = 0 then Posit (Opt.LFile)
  Else Posit (Opt.RFile);
  WinFil;
  Opt.CurD := 1-Opt.CurD;
  ShowSels;
  SaveScr (Vid^);
  If IOError <> Ok then ErrorMessage;
  LoadScr (Vid^)
End;

Procedure FileMove;
Var
  C : Char;
  I, J : Byte;
  P, F : Boolean;
  S, AS: LongInt;
  NumRead, NumWritten,
  K, M, N : Word;
  F1, F2 : File;
  SN : String;

  Function CFM : Boolean;
  Var
    C : Char;
    I, J : Byte;
  Begin
    If Mouse then MouseHide;
    Window (4, 9, 74, 7, 'Move', LightGray, Black);
    GotoXY (8, 11);
    If SelNum (Opt.CurD) = 0 then
      Dir[Opt.CurD][WinS[Opt.CurD]+WinF[Opt.CurD]].Sel := True;
    Write ('Move ', SelNum(Opt.CurD), ' file(s) to');
    GotoXY (8, 12);
    Write (Path[1-Opt.CurD]);
    I := 1;
    GotoXY (30, 13);
    If I = 1 then Color (LightCyan, Black)
    Else Color (LightGray, Black);
      Write (BMove);
    GotoXY (44, 13);
    If I = 2 then Color (LightCyan, Black)
    Else Color (LightGray, Black);
      Write (BCancel);
    If Mouse then MouseShow;
    While true do
      Begin
        Timer;
        If DKeyPressed then C := DReadKey
        Else C := #$FF;
        If Mouse then
          Begin
            MouseReadText (Opt.MX, Opt.MY, MB);
            If (MB and 1 = 1) and (Opt.MY = 13) and (Opt.MX in [30..37]) then
              Begin
                I := 1;
                C := #13
              End;
            If (MB and 1 = 1) and (Opt.MY = 13) and (Opt.MX in [44..53]) then
              C := #27
          End;
        If (C = #27) or ((I = 2) and (C = #13)) then
          Begin
            I := 2;
            If (SelNum (Opt.CurD) = 1) and
              (Dir[Opt.CurD][WinS[Opt.CurD]+WinF[Opt.CurD]].Sel = True) then
              Dir[Opt.CurD][WinS[Opt.CurD]+WinF[Opt.CurD]].Sel := False;
            C := #13
          End;
        If C = #13 then Break;
        If C = #0 then
          Begin
            C := DReadKey;
            I := 3-I;
            GotoXY (30, 13);
            If I = 1 then Color (LightCyan, Black)
            Else Color (LightGray, Black);
              Write (BMove);
            GotoXY (44, 13);
            If I = 2 then Color (LightCyan, Black)
            Else Color (LightGray, Black);
              Write (BCancel);
          End
      End;
    CFM := I = 1
  End;

Begin
  If Path[Opt.CurD] = Path[1-Opt.CurD] then Exit;
  CursorOff;
  SaveScr (Vid^);
  P := CFM;
  If Mouse then
    While MousePressed do;
  LoadScr (Vid^);
  If not P then Exit;
  M := 0;
  If not Dir[Opt.CurD][Count[Opt.CurD]-1].Sel then
    Begin
      For N := Count[Opt.CurD]-1 downto 0 do
        If not Dir[Opt.CurD][N].Sel then M := N
        Else Begin M := N+1; Break End
    End
  Else
      For N := Count[Opt.CurD]-1 downto 0 do
        If not Dir[Opt.CurD][N].Sel then
          Begin M := N; Break End;
  SN := Dir[Opt.CurD][M].Name;
  AS := SelSize (Opt.CurD);
  S := 0;
  Window (23, 9, 36, 8, 'Moving...', LightGray, Black);
  GotoXY (27, 11); Write (Per);
  For N := 0 to Count[Opt.CurD]-1 do
    If Dir[Opt.CurD][N].Sel then
      Begin
        If {Exists (Path[1-CurD]+Dir[CurD][N].Name)}
          FindName2 (Dir[Opt.CurD][N].Name) <> $FFFF then
          Begin
            F := OverWrite (Dir[Opt.CurD][N].Name);
            If not F then
              Begin
                Inc (S, Dir[Opt.CurD][N].Size);
                M := Round (S/AS*20);
                GotoXY (30, 11);
                For K := 1 to M do Write ('');
                Continue
              End
            Else
              Begin
                Opt.CurD := 1-Opt.CurD;
                If Dir[Opt.CurD][FindName(Dir[1-Opt.CurD][N].Name)].Size+
                  Free[Opt.CurD] < Dir[1-Opt.CurD][N].Size then
                  Begin
                    IOError := NoSpace;
                    IOErrorFile := Path[1-Opt.CurD]+Dir[1-Opt.CurD][N].Name;
                    Break
                  End;
                Opt.CurD := 1-Opt.CurD
              End
          End
        Else If (Free [1-Opt.CurD] < Dir[Opt.CurD][N].Size) then
          Begin
            IOError := NoSpace;
            IOErrorFile := Path[1-Opt.CurD]+Dir[Opt.CurD][N].Name;
            Break
          End;
        CopyFile (Path[Opt.CurD], Path[1-Opt.CurD], Dir[Opt.CurD][N].Name, AS, S);
        If IOError <> Ok then Break;
        Assign (F1, Path[Opt.CurD]+Dir[Opt.CurD][N].Name);
        {$I-}
        SetFAttr (F1, Archive);
        {$I+}
        If IOResult <> 0 then
          Begin
            IOErrorFile := Path[Opt.CurD]+Dir[Opt.CurD][N].Name;
            IOError := WriteError;
            Break
          End;
        {$I-}
        Erase (F1);
        {$I+}
        If IOResult <> 0 then
          Begin
            IOErrorFile := Path[Opt.CurD]+Dir[Opt.CurD][N].Name;
            IOError := DeleteError;
            Break
          End;
        Dir[Opt.CurD][N].Sel := False
      End;
  LoadScr (Vid^);
  FreeList;
  FindFiles;
  SortFiles;
  If IOError = Ok then
    If Opt.CurD = 0 then Opt.LFile := SN
    Else Opt.RFile := SN;
  If Opt.CurD = 0 then Posit (Opt.LFile)
  Else Posit (Opt.RFile);
  WinFil;
  Opt.CurD := 1-Opt.CurD;
  FreeList;
  FindFiles;
  SortFiles;
  If Opt.CurD = 0 then Posit (Opt.LFile)
  Else Posit (Opt.RFile);
  WinFil;
  Opt.CurD := 1-Opt.CurD;
  ShowSels;
  SaveScr (Vid^);
  If IOError <> Ok then ErrorMessage;
  LoadScr (Vid^)
End;

Procedure FileDelete;
Var
  P : Boolean;
  S, AS: LongInt;
  K, M, N : Word;
  F : File;
  SN : String;

  Function CFD : Boolean;
  Var
    C : Char;
    I, J : Byte;
  Begin
    If Mouse then MouseHide;
    Window (26, 9, 30, 6, 'Delete', LightGray, Black);
    GotoXY (31, 11);
    If SelNum (Opt.CurD) = 0 then Dir[Opt.CurD][WinS[Opt.CurD]+WinF[Opt.CurD]].Sel := True;
    Write ('Delete ', SelNum (Opt.CurD):3, ' file(s) ?');
    I := 1;
    GotoXY (30, 12);
    If I = 1 then Color (LightCyan, Black)
    Else Color (LightGray, Black);
      Write (BDelete);
    GotoXY (42, 12);
    If I = 2 then Color (LightCyan, Black)
    Else Color (LightGray, Black);
      Write (BCancel);
    If Mouse then MouseShow;
    While true do
      Begin
        Timer;
        If DKeyPressed then C := DReadKey
        Else C := #$FF;
        If Mouse then
          Begin
            MouseReadText (Opt.MX, Opt.MY, MB);
            If (MB and 1 = 1) and (Opt.MY = 12) and (Opt.MX in [30..39]) then
              Begin
                I := 1;
                C := #13
              End;
            If (MB and 1 = 1) and (Opt.MY = 12) and (Opt.MX in [42..51]) then
              C := #27
          End;
        If (C = #27) or ((I = 2) and (C = #13)) then
          Begin
            I := 2;
            If (SelNum (Opt.CurD) = 1) and
              (Dir[Opt.CurD][WinS[Opt.CurD]+WinF[Opt.CurD]].Sel = True) then
              Dir[Opt.CurD][WinS[Opt.CurD]+WinF[Opt.CurD]].Sel := False;
            C := #13
          End;
        If C = #13 then Break;
        If C = #0 then
          Begin
            C := DReadKey;
            I := 3-I;
            GotoXY (30, 12);
            If I = 1 then Color (LightCyan, Black)
            Else Color (LightGray, Black);
              Write (BDelete);
            GotoXY (42, 12);
            If I = 2 then Color (LightCyan, Black)
            Else Color (LightGray, Black);
              Write (BCancel);
          End
      End;
    CFD := I = 1
  End;

Begin
  CursorOff;
  SaveScr (Vid^);
  P := CFD;
  If Mouse then
    While MousePressed do;
  LoadScr (Vid^);
  If not P then Exit;
  Window (23, 9, 36, 5, 'Deleting...', LightGray, Black);
  GotoXY (27, 11); Write (Per);
  M := 0;
  If not Dir[Opt.CurD][Count[Opt.CurD]-1].Sel then
    Begin
      For N := Count[Opt.CurD]-1 downto 0 do
        If not Dir[Opt.CurD][N].Sel then M := N
        Else Begin M := N+1; Break End
    End
  Else
      For N := Count[Opt.CurD]-1 downto 0 do
        If not Dir[Opt.CurD][N].Sel then
          Begin M := N; Break End;
  SN := Dir[Opt.CurD][M].Name;
  AS := SelSize (Opt.CurD);
  S := 0;
  For N := 0 to Count[Opt.CurD]-1 do
    If Dir[Opt.CurD][N].Sel then
      Begin
        Timer;
        Assign (F, Path[Opt.CurD]+Dir[Opt.CurD][N].Name);
        Inc (S, Dir[Opt.CurD][N].Size);
        If AS = 0 then M := 0
        Else M := Round (S/AS*20);
        GotoXY (30, 11);
        For K := 1 to M do Write ('');
        {$I-}
        SetFAttr (F, Archive);
        {$I+}
        If IOResult <> 0 then
          Begin
            IOErrorFile := Path[Opt.CurD]+Dir[Opt.CurD][N].Name;
            IOError := WriteError;
            Break
          End;
        {$I-}
        Erase (F);
        {$I+}
        If IOResult <> 0 then
          Begin
            IOErrorFile := Path[Opt.CurD]+Dir[Opt.CurD][N].Name;
            IOError := DeleteError;
            Break
          End
      End;
  LoadScr (Vid^);
  FreeList;
  FindFiles;
  SortFiles;
  If IOError = Ok then
    If Opt.CurD = 0 then Opt.LFile := SN
    Else Opt.RFile := SN;
  If Opt.CurD = 0 then Posit (Opt.LFile)
  Else Posit (Opt.RFile);
  WinFil;
  If Path[0] = Path[1] then
  Begin
    OneDir;
    Opt.CurD := 1-Opt.CurD;
    Posit ('..');
    WinFil;
    Opt.CurD := 1-Opt.CurD;
  End;
  If Path[0][1]=Path[1][1] then
    Free[1-Opt.CurD] := Free[Opt.CurD];
  ShowSels;
  SaveScr (Vid^);
  If IOError <> Ok then ErrorMessage;
  LoadScr (Vid^)
End;

Procedure FileRename;
Var
  C : Char;
  F : File;
  Nm,
  S : String;
  I, J : Word;
Function NN (S : String) : String;
Var
  I : Byte;
Begin
  If S <> '' then
    Begin
      While (S<>'') and (S[1]=' ') do
        S := Copy(S,2,Length(S)-1);
      While (S<>'') and (S[Length(S)]=' ') do
        Dec(S[0]);
      For I := 1 to Length (S) do
        If not (S[I] in ['.','A'..'Z','0'..'9','-','_','$','&','@','%','(',')','^','`','''','{','}','~','!','#']) then
          Begin
            S := '';
            Break
          End;
    End;
  If S[Length(S)] = '.' then Dec(S[0]);
  NN := S
End;
Begin
  If Mouse then MouseHide;
  SaveScr (Vid^);
  Window (25, 10, 32, 6, 'Rename', LightGray, Black);
  Nm := Dir[Opt.CurD][WinF[Opt.CurD]+WinS[Opt.CurD]].Name;
  S := Nm;
  GotoXY (29, 12);
  Write ('Rename "'+S+'" to');
  GotoXY (29, 13);
  Color (LightCyan, Black);
  Write (S);
  While WhereX < 41 do Write (' ');
  If Mouse then MouseShow;
  Repeat
    GotoXY (29, 13);
    Write (S);
    While WhereX < 41 do Write (' ');
    GotoXY (29, 13);
    ReadSK (S, 12);
    S := NN (S);
    If (S = '') or (S = Nm) then Break;
    If not Exists (Path[Opt.CurD]+S) then Break
    Else If UpStr (S) <> Nm then
      Begin
        GotoXY (29, 13);
        Color (LightGray, Black);
        If Mouse then MouseHide;
        Write ('Overwrite ? (Y/N)');
        If Mouse then MouseShow;
        Repeat
          If DKeyPressed then C := UpCase (DReadKey)
          Else C := #$FF;
          If C = #0 then Begin DReadKey; C := #$FF End;
          If C in [#27, 'N'] then Break;
          If C in [#13, 'Y'] then
            Begin
              Assign (F, Path[Opt.CurD]+S);
              {$I-}
              SetFAttr (F, Archive);
              {$I+}
              If IOResult <> 0 then
                Begin
                  IOError := WriteError;
                  IOErrorFile := Path[Opt.CurD]+S;
                  LoadScr (Vid^);
                  ErrorMessage;
                  LoadScr (Vid^);
                  Exit
                End;
              {$I-}
              Erase (F);
              {$I+}
              If IOResult <> 0 then
                Begin
                  IOError := DeleteError;
                  IOErrorFile := Path[Opt.CurD]+S;
                  LoadScr (Vid^);
                  ErrorMessage;
                  LoadScr (Vid^);
                  Exit
                End;
              J := FindName(S);
              If J < Count[Opt.CurD]-1 then
                For I := J to Count[Opt.CurD]-2 do
                  Dir[Opt.CurD,I] := Dir[Opt.CurD,I+1];
              Dec (Count[Opt.CurD]);
              Assign (F, Path[Opt.CurD]+Nm);
              {$I-}
              Rename (F, Path[Opt.CurD]+S);
              {$I+}
              If IOResult <> 0 then
                Begin
                  IOError := RenameError;
                  IOErrorFile := Path[Opt.CurD]+Nm;
                  LoadScr (Vid^);
                  SortFiles;
                  Posit (S);
                  If Opt.CurD = 0 then Opt.LFile := S
                  Else Opt.RFile := S;
                  WinFil;
                  SaveScr (Vid^);
                  ErrorMessage;
                  LoadScr (Vid^);
                  Exit
                End;
              Dir[Opt.CurD][FindName(Nm)].Name := S;
              LoadScr (Vid^);
              SortFiles;
              Posit (S);
              If Opt.CurD = 0 then Opt.LFile := S
              Else Opt.RFile := S;
              WinFil;
              If Path[0] = Path[1] then
                Begin
                  OneDir;
                  Opt.CurD := 1-Opt.CurD;
                  WinFil;
                  Opt.CurD := 1-Opt.CurD;
                End;
              ShowSels;
              Exit
            End
        Until false;
        GotoXY (29, 13);
        Write ('':17);
        Color (LightCyan, Black)
      End
  Until false;
  LoadScr (Vid^);
  If (S = '') or Exists (Path[Opt.CurD]+S) then Exit;
  Assign (F, Path[Opt.CurD]+Nm);
  {$I-}
  SetFAttr (F, Archive);
  Rename (F, Path[Opt.CurD]+S);
  {$I+}
  If IOResult <> 0 then
    Begin
      SaveScr (Vid^);
      IOError := RenameError;
      IOErrorFile := Path[Opt.CurD]+Nm;
      ErrorMessage;
      LoadScr (Vid^);
      Exit
    End;
  Dir[Opt.CurD][FindName(Nm)].Name := S;
  SortFiles;
  Posit (S);
  If Opt.CurD = 0 then Opt.LFile := S
  Else Opt.RFile := S;
  WinFil;
  If Path[0] = Path[1] then
  Begin
    OneDir;
    Opt.CurD := 1-Opt.CurD;
    WinFil;
    Opt.CurD := 1-Opt.CurD;
  End;
  ShowSels
End;

Procedure MakeDir;
Var
  S : String;
Begin
  If Mouse then MouseHide;
  SaveScr (Vid^);
  Window (26, 10, 28, 6, 'Make Directory', LightGray, Black);
  S := '';
  GotoXY (30, 12);
  Write ('Create the directory');
  GotoXY (30, 13);
  Color (LightCyan, Black);
  While WhereX < 42 do Write (' ');
  GotoXY (30, 13);
  ReadSK (S, 12);
  LoadScr (Vid^);
  MouseShow;
  CursorOff;
  If S[1] = '.' then S := '';
  If (Length (S) > 8) and (Pos ('.', S) = 0) then
    S := Copy (S, 1, 8);
  If (Pos ('.', S) > 0) and (Length (S) - Pos ('.', S) > 3) then
    S := Copy (S, 1, Pos ('.', S)+3);
  While (S[1] = ' ') and (Length (S) > 0) do
    S := Copy (S, 2, Length (S)-1);
  While (S[Length (S)] = ' ') and (Length (S) > 0) do
    S := Copy (S, 1, Length (S)-1);
  If (S = ' ') or (S = '') then Exit;
  CD (Path[Opt.CurD]);
  {$I-}
  MkDir (S);
  {$I+}
  If IOResult <> 0 then
    Begin
      SaveScr (Vid^);
      IOError := MakeError;
      IOErrorFile := Path[Opt.CurD]+S;
      ErrorMessage;
      LoadScr (Vid^);
      Exit
    End;
  FreeList;
  FindFiles;
  SortFiles;
  WinS[Opt.CurD] := FindName (S);
  WinFil;
  If Path[0] = Path[1] then
  Begin
    OneDir;
    Opt.CurD := 1-Opt.CurD;
    WinFil;
    Opt.CurD := 1-Opt.CurD;
  End;
  ShowSels
End;

Procedure RecDirDel (Dir : String; Size : LongInt; Var Sz : LongInt);
Var
  R : Registers;
  F : File;
  S : SearchRec;
  K, M : Word;
  L : LongInt;
Label LNext;
Begin
  If IOError <> Ok then Exit;
  If Dir[Length (Dir)] <> '\' then Dir := Dir+'\';
  FindFirst (Dir+'*.*', AnyFile-VolumeID, S);
  While DOSError = 0 do
    Begin
      If S.Attr and Directory = Directory then Goto LNext;
      Timer;
      If Size = 0 then M := 0
      Else M := Round (Sz/Size*20);
      GotoXY (30, 11);
      For K := 1 to M do Write ('');
      Assign (F, Dir+S.Name);
      {$I-}
      SetFAttr (F, Archive);
      {$I+}
      If IOResult <> 0 then
        Begin
          IOError := WriteError;
          IOErrorFile := Dir+S.Name;
          Exit
        End;
      L := S.Size;
      {$I-}
      Erase (F);
      {$I+}
      If IOResult <> 0 then
        Begin
          IOError := DeleteError;
          IOErrorFile := Dir+S.Name;
          Exit
        End;
      Inc (Sz, L);
LNext:
      FindNext (S)
    End;
  FindFirst (Dir+'*.*', AnyFile-VolumeID, S);
  While DOSError = 0 do
    Begin
      If (S.Attr and Directory = Directory) and (S.Name[1] <> '.') then
         Begin
           RecDirDel (Dir+S.Name, Size, Sz);
           If IOError = Ok then RmDir (Dir+S.Name);
           R.AH := $1A;
           R.DS := Seg (S);
           R.DX := Ofs (S);
           MSDOS (R)
         End;
      FindNext (S)
    End
End;

Procedure DeleteDir;
Var
  C : Char;
  N : Word;
  I, J : Byte;
  SubDirs,
  Files   : Word;
  Sz,
  Size    : LongInt;
  S       : String;
Label
  L;
Begin
  If Mouse then MouseHide;
  SaveScr (Vid^);
  CursorOff;
  Window (22, 9, 39, 6, 'Delete', LightGray, Black);
  GotoXY (26, 11);
  Write ('Delete directory '+Dir[Opt.CurD][WinF[Opt.CurD]+WinS[Opt.CurD]].Name+' ?');
  I := 1;
  GotoXY (26, 12);
  If I = 1 then Color (LightCyan, Black)
  Else Color (LightGray, Black);
    Write (BDelete);
  GotoXY (47, 12);
  If I = 2 then Color (LightCyan, Black)
  Else Color (LightGray, Black);
    Write (BCancel);
  If Mouse then MouseShow;
  While true do
    Begin
      Timer;
      If DKeyPressed then C := DReadKey
      Else C := #$FF;
        If Mouse then
          Begin
            MouseReadText (Opt.MX, Opt.MY, MB);
            If (MB and 1 = 1) and (Opt.MY = 12) and (Opt.MX in [26..35]) then
              Begin
                I := 1;
                C := #13
              End;
            If (MB and 1 = 1) and (Opt.MY = 12) and (Opt.MX in [47..56]) then
              C := #27
          End;
      If (C = #27) or ((I = 2) and (C = #13)) then
        Begin
          I := 2;
          If (SelNum (Opt.CurD) = 1) and
            (Dir[Opt.CurD][WinS[Opt.CurD]+WinF[Opt.CurD]].Sel = True) then
            Dir[Opt.CurD][WinS[Opt.CurD]+WinF[Opt.CurD]].Sel := False;
          C := #13
        End;
      If C = #13 then Break;
      If C = #0 then
        Begin
          C := DReadKey;
          I := 3-I;
          GotoXY (26, 12);
          If I = 1 then Color (LightCyan, Black)
          Else Color (LightGray, Black);
            Write (BDelete);
          GotoXY (47, 12);
          If I = 2 then Color (LightCyan, Black)
          Else Color (LightGray, Black);
            Write (BCancel);
        End
    End;
  If Mouse then While MousePressed do Timer;
  LoadScr (Vid^);
  If I = 1 then
       Begin
         Window (23, 9, 36, 5, 'Deleting...', LightGray, Black);
         GotoXY (27, 11); Write (Per);
         SubDirs := 0;
         Files := 0;
         Size := 0;
         Sz := 0;
         S := Path[Opt.CurD]+Dir[Opt.CurD][WinF[Opt.CurD]+WinS[Opt.CurD]].Name;
         If not CD (Path[Opt.CurD]) then
           Begin
             IOError := DeleteError;
             IOErrorFile := S;
             LoadScr (Vid^);
             If IOError <> Ok then ErrorMessage;
             LoadScr (Vid^);
             Exit
           End;
         FullDir (S, SubDirs, Files, Size);
         RecDirDel (S, Size, Sz);
         If IOError <> Ok then
           Goto L;
         {$I-}
         RmDir (S);
         {$I+}
         If IOResult <> 0 then
           Begin
             IOError := DeleteError;
             IOErrorFile := Path[Opt.CurD]+S
           End;
L:
         FreeList;
         FindFiles;
         SortFiles;
         LoadScr (Vid^);
         WinFil;
         If Path[0][1] = Path[1][1] then
           Free[1-Opt.CurD] := Free[Opt.CurD];
         If Path[0] = Path[1] then
           Begin
             OneDir;
             Opt.CurD := 1-Opt.CurD;
             Posit ('..');
             WinFil;
             Opt.CurD := 1-Opt.CurD;
           End;
         If Path[1-Opt.CurD] = S+'\' then
           Begin
             Path[1-Opt.CurD] := Path[Opt.CurD];
             ManWin (Path[Opt.CurD], 40*(1-Opt.CurD)+1);
             OneDir;
             Opt.CurD := 1-Opt.CurD;
             WinFil;
             Opt.CurD := 1-Opt.CurD;
           End;
         ShowSels
       End;
  SaveScr (Vid^);
  If IOError <> Ok then ErrorMessage;
  LoadScr (Vid^)
End;

Procedure InvertGroup;
Var N : Word;
Begin
  If Count[Opt.CurD] = 0 then Exit;
  For N := 0 to Count[Opt.CurD]-1 do
    If Dir[Opt.CurD][N].Attr and Directory = 0 then
      Dir[Opt.CurD][N].Sel := Dir[Opt.CurD][N].Sel xor true;
  WinFil;
  ShowSels
End;

Procedure Search;
Var
  S : String;
  C : Char;
  N : Word;
Label
  L;

  Procedure WN (S : String);
  Var I : Byte;
  Begin
    CursorOff;
    Color (LightGray, Black);
    For I := 40*Opt.CurD+10 to 40*Opt.CurD+31 do
      Begin
        GotoXY (I, WH-3); Write ('');
        GotoXY (I, WH-1); Write ('')
      End;
    GotoXY (40*Opt.CurD+9, WH-3); Write ('');
    GotoXY (40*Opt.CurD+9, WH-2); Write ('');
    GotoXY (40*Opt.CurD+9, WH-1); Write ('');
    GotoXY (40*Opt.CurD+32, WH-3); Write ('');
    GotoXY (40*Opt.CurD+32, WH-2); Write ('');
    GotoXY (40*Opt.CurD+32, WH-1); Write ('');
    GotoXY (40*Opt.CurD+10, WH-2); Write (' Search: ');
    Color (LightCyan, Black);
    Write (' ':12);
    Color (LightGray, Black);
    Write (' ');
    Color (LightCyan, Black);
    CursorOn (Up, Dn);
    GotoXY (40*Opt.CurD+19, WH-2);
    Write (S);
  End;

Begin
  S := '';
  WN (S);
  C := #$FF;
  While Mem[0:1047] and 8 <> 0 do;
  Repeat
    Timer;
    CursorOn (Up, Dn);
    GotoXY (40*Opt.CurD+19+Length(S), WH-2);
    Color (LightCyan, Black);
    If DKeyPressed then C := DReadKey
    Else C := #$FF;
    If C = #0 then
      Begin
        C := DReadKey;
        If C <> #82 then Break;
        If Dir[Opt.CurD][WinF[Opt.CurD]+WinS[Opt.CurD]].Attr and Directory = 0 then
          Dir[Opt.CurD][WinF[Opt.CurD]+WinS[Opt.CurD]].Sel :=
            Dir[Opt.CurD][WinF[Opt.CurD]+WinS[Opt.CurD]].Sel xor True;
        WinFil;
        ShowSels;
        WN (S);
        C := #$FF
      End;
    If (C = #8) and (Length (S) > 0) then
      Begin S := Copy (S, 1, Length (S)-1); WN (S) End;
    If (C = #10) and (Count[Opt.CurD] > 0) then
      If (WinF[Opt.CurD]+WinS[Opt.CurD]+1 < Count[Opt.CurD]) then
        Begin N := WinF[Opt.CurD]+WinS[Opt.CurD]+1; Goto L End;
    If (C in [#32..#254]) and (Length (S) < 12) then
      Begin
        S := S+C; Write (C);
        If Count[Opt.CurD] > 0 then
          For N := WinF[Opt.CurD]+WinS[Opt.CurD] to Count[Opt.CurD]-1 do
            Begin
L:
              If Copy (Dir[Opt.CurD][N].Name, 1, Length(S)) = UpStr (S) then
                Begin
                  Posit (Dir[Opt.CurD][N].Name);
                  WinFil;
                  ShowSels;
                  WN (S);
                  Break
                End
            End;
          If (Count[Opt.CurD] > 0) and (UpStr (S) <>
              Copy (Dir[Opt.CurD][WinF[Opt.CurD]+WinS[Opt.CurD]].Name, 1, Length (S))) then
              For N := 0 to WinF[Opt.CurD]+WinS[Opt.CurD] do
                Begin
                  If Copy (Dir[Opt.CurD][N].Name, 1, Length(S)) = UpStr (S) then
                    Begin
                      Posit (Dir[Opt.CurD][N].Name);
                      WinFil;
                      ShowSels;
                      WN (S);
                      Break
                    End
                End
      End;
  Until (C = #27) or (C = #13) or (Mem[0:1047] and 8 <> 0);
  ManWin (Path[Opt.CurD], Opt.CurD*40+1);
  ShowSels;
  While Mem[0:1047] and 8 <> 0 do
End;

Procedure MenuInit;
Var
  T : Text;
  N : Byte;
Begin
  IOError := Ok;
  MN := 0;
  MF := '';
  If Exists (Path[Opt.CurD]+MNU) then
    MF := Path[Opt.CurD]+MNU
  Else
    If Exists (P+MNU) then
      MF := P+MNU;
  If MF = '' then Exit;
  IOErrorFile := MF;
  IOError := ReadError;
  Assign (T, MF);
  {$I-} Reset (T); {$I+}
  If IOResult <> 0 then Exit;
  Repeat
    {$I-} ReadLn (T, S); {$I+}
    If IOResult <> 0 then Exit;
    If (S <> '') and (S[1] <> ' ') then
      Begin
        Menu[MN] := S;
        Inc (MN)
      End;
  Until (MN = 20) or (EOF (T));
  Close (T);
  IOError := Ok
End;

Function MenuS : Boolean;
Var
  T1,
  T2: Text;
  I, J,
  N : Byte;
  C : Char;
  F : Boolean;
  X,
  Y : Word;
Label
  L;

  Procedure WC (I : Byte);
  Begin
    If Mouse then MouseHide;
    GotoXY (4+(74-N) div 2+1,3+(21-MN) div 2+I);
    Color (Cyan, Black);
    Write (Menu[I]);
    While WhereX < 3+(74-N) div 2+N do Write (' ');
    If Mouse then MouseShow
  End;

  Procedure W (I : Byte);
  Begin
    If Mouse then MouseHide;
    GotoXY (4+(74-N) div 2+1,3+(21-MN) div 2+I);
    Color (Black, White);
    Write (Menu[I]);
    While WhereX < 3+(74-N) div 2+N do Write (' ');
    If Mouse then MouseShow
  End;

Begin
  IOError := Ok;
  If Mouse then While MousePressed do;
  EditMenu := False;
  F := False;
  If MN = 0 then Goto L;
  CursorOff;
  N := 16;
  For I := 0 to MN-1 do
    If Length (Menu[I]) > N then N := Length (Menu[I]);
  Inc (N, 2);
  SaveScr (Vid^);
  Window (1 + (74-N) div 2, 1 + (21-MN) div 2, N+6, MN+4, 'User Menu',
                                                     LightCyan, White);
  For I := 0 to MN-1 do
    WC (I);
  I := 0;
  W (I);
  X := 4+(74-N) div 2+1;
  Y := 3+(21-MN) div 2;
  C := #$FF;
  While true do
    Begin
      Timer;
      If DKeyPressed then C := DReadKey
      Else C := #$FF;
      MouseReadText (Opt.MX, Opt.MY, MB);
      If (MB and 1 = 1) then
        If (Opt.MX in [X..X+N-3]) and
          (Opt.MY in [Y..Y+MN-1]) then
            Begin
              I := Opt.MY - Y;
              C := #13
            End
        Else
          If not ((Opt.MX in [X-4..X+N+1]) and (Opt.MY in [Y-2..Y+MN+1])) then
            C := #27;
      If C in [#33..#127] then
        For J := 0 to MN-1 do
          If UpCase (Menu[J][1]) = UpCase (C) then
            Begin I := J; C := #13 End;
      If C = #27 then Break;
      If C = #13 then
        Begin
          F := True;
          Assign (T1, MF);
          Assign (T2, P+BAT);
          {$I-} Reset (T1); {$I+}
          If IOResult <> 0 then
            Begin
              IOError := ReadError;
              IOErrorFile := MF;
              Break
            End;
          {$I-} Rewrite (T2); {$I+}
          If IOResult <> 0 then
            Begin
              IOError := WriteError;
              IOErrorFile := P+BAT;
              Close (T1);
              Break
            End;
          {$I-} WriteLn (T2, '@ECHO OFF'); {$I+}
          If IOResult <> 0 then
            Begin
              IOError := WriteError;
              IOErrorFile := P+BAT;
              Close (T1);
              Close (T2);
              Break
            End;
          While not EOF (T1) do
            Begin
              ReadLn (T1, S);
              If IOResult <> 0 then
                Begin
                  IOError := ReadError;
                  IOErrorFile := MF;
                  Close (T1);
                  Close (T2);
                  Break
                End;
              If S = Menu[I] then Break;
            End;
          While not EOF (T1) do
            Begin
              ReadLn (T1, S);
              If IOResult <> 0 then
                Begin
                  IOError := ReadError;
                  IOErrorFile := MF;
                  Close (T1);
                  Close (T2);
                  Break
                End;
              If S[1] <> ' ' then Break;
              WriteLn (T2, S);
              If IOResult <> 0 then
                Begin
                  IOError := WriteError;
                  IOErrorFile := P+BAT;
                  Close (T1);
                  Close (T2);
                  Break
                End;
            End;
          Close (T1);
          Close (T2);
          Break
        End;
      If C = #0 then
        Begin
          C := DReadKey;
          Case C of
            #62 : {F4}
              Begin
                EditMenu := True;
                LoadScr (Vid^);
                Exit
              End;
            #72 : {UP}
              If I > 0 then
                Begin
                  WC (I);
                  Dec (I);
                  W (I)
                End;
            #80 : {Down}
              If I < MN-1 then
                Begin
                  WC (I);
                  Inc (I);
                  W (I)
                End;
            #71,  {Home}
            #73 : {PgUp}
              If I > 0 then
                Begin
                  WC (I);
                  I := 0;
                  W (I)
                End;
            #79,  {End}
            #81 : {PgDn}
              If I < MN-1 then
                Begin
                  WC (I);
                  I := MN-1;
                  W (I)
                End
          End
        End
    End;
  LoadScr (Vid^);
L:
  If Mouse then While MousePressed do;
  MenuS := F
End;

Function EE (S : String) : String;
Var
  P : PathStr;
  D : DirStr;
  N : NameStr;
  E : ExtStr;
  I : Byte;
Label
  L;
Begin
  P := Dir[Opt.CurD][WinF[Opt.CurD]+WinS[Opt.CurD]].Name;
  FSplit (P, D, N, E);
  P := '';
  If S = '' then Goto L;
  I := 0;
  While I < Length (S) do
    Begin
      Inc (I);
      If Copy (S, I, 2) = '!!' then
         Begin
           P := P+'!';
           Inc (I);
           Continue
         End;
      If Copy (S, I, 3) = '!.!' then
        Begin
          P := P+N+E;
          Inc (I, 2);
          Continue
        End;
      If (S[I] = '!') and ( (I = Length (S))  or
         ((I < Length(S)) and (S[I+1] <> '\') and (S[I+1] <> ':')) ) then
         Begin
           P := P+N;
           Continue
         End;
      If Copy (S, I, 2) = '!\' then
         Begin
           P := P+Path[Opt.CurD];
           Inc (I);
           Continue
         End;
      If Copy (S, I, 2) = '!:' then
         Begin
           P := P+Copy(Path[Opt.CurD],1,2);
           Inc (I);
           Continue
         End;
      P := P + S[I]
    End;
L:
  EE := P
End;

Function ES (Ext : String) : String;
Var
  T : Text;
  S : String;
Label
  L;
Begin
  S := '';
  If not Exists (P+'FCOM.EXT') then Goto L;
  Assign (T, P+'FCOM.EXT');
  Reset (T);
  Repeat
    ReadLn (T, S);
    S := UpStr (S)
  Until (EOF (T)) or (Copy(S,1,Length(Ext)+1) = Ext+':');
  Close (T);
  If Copy(S,1,Length(Ext)+1) <> Ext+':' then S := '';
L:
  If (S = '') or (Pos(':',S)=Length(S)) or (Pos(':',S)=0) then ES := ''
  Else ES := Copy (S, Pos(':',S)+1, Length (S)-Pos(':',S))
End;

Procedure SaveScreen;
Var
  N : Word;
  I, J,
  X, Y : Byte;
Label
  L,
  E;
Begin
  X := WhereX;
  Y := WhereY;
  CursorOff;
  Move (GetScreenPtr^, Buf^, GetScreenSize);
  If not Snow then
    For I := 1 to 40 do
      Begin
        ScrollLeft(1,1,40,GetRowNum,$0720);
        ScrollRight(41,1,40,GetRowNum,$0720);
        If Mouse then MouseReadText (MX1, MY1, MB1);
        If DKeyPressed or
           (Mouse and ((Opt.MX <> MX1) or (Opt.MY <> MY1))) then Goto E
      End;
  Color (Black, LightGray);
  Randomize;
  Repeat
    For N := 1 to 50 do
      Begin
L:
        Buf^[10000+N*2-1] := 1 + Random (GetColNum);
        Buf^[10000+N*2  ] := 1 + Random (GetRowNum);
        If (Buf^[10000+N*2-1] = GetColNum) and
           (Buf^[10000+N*2  ] = GetRowNum) then Goto L;
        GotoXY (Buf^[10000+N*2-1],Buf^[10000+N*2]);
        Write ('*');
        Delay (50);
        If DKeyPressed then Break;
        If Mouse then
          Begin
            MouseReadText (MX1, MY1, MB1);
            If (Opt.MX <> MX1) or (Opt.MY <> MY1) then Goto E
          End
      End;
    For N := 1 to 50 do
      Begin
        GotoXY (Buf^[10000+N*2-1],Buf^[10000+N*2]);
        Write (' ');
        Delay (50);
        If DKeyPressed then Break;
        If Mouse then
          Begin
            MouseReadText (MX1, MY1, MB1);
            If (Opt.MX <> MX1) or (Opt.MY <> MY1) then Goto E
          End
      End;
  Until DKeyPressed;
E:
  Move (Buf^, GetScreenPtr^, GetScreenSize);
  GotoXY (X, Y);
  CursorOn (Up, Dn);
  Delay (333);
  While DKeyPressed do DReadKey
End;

Procedure Select;
Var
  S : String;
  N : Word;
Begin
  S := Opt.Mask;
  SaveScr (Vid^);
  Window (28, 10, 26, 6, 'Select', LightGray, Black);
  GotoXY (32, 12);
  Write ('Select the files');
  GotoXY (32, 13);
  Color (LightCyan, Black);
  Write (S);
  While WhereX < 44 do Write (' ');
  Repeat
    GotoXY (32, 13);
    Write (S);
    While WhereX < 44 do Write (' ');
    GotoXY (32, 13);
    ReadSK (S, 12);
    If S = '' then Break
  Until S <> '';
  LoadScr (Vid^);
  While (S <> '') and (S[Length(S)] = ' ') do
    S := Copy (S, 1, Length (S) - 1);
  If S = '' then Exit;
  Opt.Mask := S;
  For N := 0 to Count[Opt.CurD]-1 do
    If (Dir[Opt.CurD][N].Attr and Directory = 0) and
       CMask (UpStr(Opt.Mask), Dir[Opt.CurD][N].Name) then
         Dir[Opt.CurD][N].Sel := True;
  WinFil;
  ShowSels
End;

Procedure DeSelect;
Var
  S : String;
  N : Word;
Begin
  S := Opt.Mask;
  SaveScr (Vid^);
  Window (28, 10, 26, 6, 'Deselect', LightGray, Black);
  GotoXY (32, 12);
  Write ('Deselect the files');
  GotoXY (32, 13);
  Color (LightCyan, Black);
  Write (S);
  While WhereX < 44 do Write (' ');
  Repeat
    GotoXY (32, 13);
    Write (S);
    While WhereX < 44 do Write (' ');
    GotoXY (32, 13);
    ReadSK (S, 12);
    If S = '' then Break
  Until S <> '';
  LoadScr (Vid^);
  While (S <> '') and (S[Length(S)] = ' ') do
    S := Copy (S, 1, Length (S) - 1);
  If S = '' then Exit;
  Opt.Mask := S;
  For N := 0 to Count[Opt.CurD]-1 do
    If (Dir[Opt.CurD][N].Attr and Directory = 0) and
       CMask (UpStr(Opt.Mask), Dir[Opt.CurD][N].Name) then
         Dir[Opt.CurD][N].Sel := False;
  WinFil;
  ShowSels
End;

Procedure DirView;
Var
  SubDirs,
  Files   : Word;
  Size    : LongInt;
  S       : String;
  C       : Char;
Begin
  If Mouse then MouseHide;
  If Mouse then While MousePressed do;
  SubDirs := 0;
  Files := 0;
  Size := 0;
  CursorOff;
  SaveScr (Vid^);
  Window (25, 8, 30, 10, 'Directory View', LightGray, Black);
  GotoXY (35, 12); WriteLn ('Counting...');
  FullDir (Path[Opt.CurD]+Dir[Opt.CurD][WinF[Opt.CurD]+WinS[Opt.CurD]].Name, SubDirs, Files,
                                                                      Size);
  GotoXY (29, 11); WriteLn ('Subdirs  :  '+LongStr (SubDirs,11));
  GotoXY (29, 12); WriteLn ('Files    :  '+LongStr (Files,11));
  GotoXY (29, 13); Write   ('Size     :  ');
  S := LongStr (Size,11);
  If S[Length(S)] = 'K' then S := Copy (S, 2, Length(S)-1);
  Write (S);
  Color (LightCyan, Black);
  GotoXY (37, 15);
  WriteLn (BOK);
  MouseShow;
  While true do
    Begin
      If DKeyPressed then C := DReadKey
      Else C := #$FF;
      If Mouse then
        Begin
          MouseReadText (Opt.MX, Opt.MY, MB);
          If (MB and 1 = 1) then C := #27
        End;
      If (C = #27) or (C = #13) then Break;
      If C = #0 then C := DReadKey;
      Timer
    End;
  If Mouse then
    While MousePressed do;
  LoadScr (Vid^)
End;

Procedure ComparePanels;
Var
  N, M : Word;
Begin
  If (Count[Opt.CurD]=0) or (Count[1-Opt.CurD]=0) then Exit;
  For N := 0 to Count[Opt.CurD]-1 do
    If Dir[Opt.CurD][N].Attr and Directory = 0 then
      Dir[Opt.CurD][N].Sel := true;
  For N := 0 to Count[1-Opt.CurD]-1 do
    If Dir[1-Opt.CurD][N].Attr and Directory = 0 then
      Dir[1-Opt.CurD][N].Sel := true;
  For N := 0 to Count[Opt.CurD]-1 do
    For M := 0 to Count[1-Opt.CurD]-1 do
      If
          (Dir[Opt.CurD][N].Name = Dir[1-Opt.CurD][M].Name) and
          (Dir[Opt.CurD][N].Size = Dir[1-Opt.CurD][M].Size) and
          (Dir[Opt.CurD][N].Time = Dir[1-Opt.CurD][M].Time)
         then
           Dir[Opt.CurD][N].Sel := false;
  For N := 0 to Count[1-Opt.CurD]-1 do
    For M := 0 to Count[Opt.CurD]-1 do
      If
          (Dir[1-Opt.CurD][N].Name = Dir[Opt.CurD][M].Name) and
          (Dir[1-Opt.CurD][N].Size = Dir[Opt.CurD][M].Size) and
          (Dir[1-Opt.CurD][N].Time = Dir[Opt.CurD][M].Time)
         then
           Dir[1-Opt.CurD][N].Sel := false;
  WinFil;
  Opt.CurD := 1-Opt.CurD;
  WinFil;
  Opt.CurD := 1-Opt.CurD;
  ShowSels
End;

Procedure CopyTree (Dir1, Dir2 : String; Size : LongInt; Var Sz : LongInt);
Var
  R : Registers;
  S : SearchRec;
Begin
  If IOError <> Ok then Exit;
  If Dir1[Length (Dir1)] <> '\' then Dir1 := Dir1+'\';
  If Dir2[Length (Dir2)] <> '\' then Dir2 := Dir2+'\';
  FindFirst (Dir1+'*.*', AnyFile-VolumeID, S);
  While DOSError = 0 do
    Begin
      If S.Attr and Directory = Directory then
        Begin
          If S.Name[1] <> '.' then
            Begin
              {$I-}
              MkDir (Dir2+S.Name);
              {$I+}
              If IOResult <> 0 then
                Begin
                  IOError := MakeError;
                  IOErrorFile := Dir2+S.Name;
                  Exit
                End
            End
        End
      Else
        Begin
          CopyFile (Dir1, Dir2, S.Name, Size, Sz);
          If IOError <> Ok then Exit
        End;
      FindNext (S)
    End;
  FindFirst (Dir1+'*.*', AnyFile-VolumeID, S);
  While DOSError = 0 do
    Begin
      If (S.Attr and Directory = Directory) and
         (S.Name[1] <> '.') then
         Begin
           CopyTree (Dir1+S.Name, Dir2+S.Name, Size, Sz);
           R.AH := $1A;
           R.DS := Seg (S);
           R.DX := Ofs (S);
           MSDOS (R)
         End;
      FindNext (S)
    End
End;

Procedure DirCopy;
Var
  SubDirs,
  Files   : Word;
  Sz,
  Size    : LongInt;
  S       : SearchRec;
  P       : Boolean;

  Function CFC : Boolean;
  Var
    C : Char;
    I, J : Byte;
  Begin
    If Mouse then MouseHide;
    Window (4, 9, 74, 7, 'Copy', LightGray, Black);
    GotoXY (8, 11);
    Write ('Copy directory '+Dir[Opt.CurD][WinS[Opt.CurD]+WinF[Opt.CurD]].Name+' to');
    GotoXY (8, 12);
    Write (Path[1-Opt.CurD]);
    I := 1;
    GotoXY (30, 13);
    If I = 1 then Color (LightCyan, Black)
    Else Color (LightGray, Black);
      Write (BCopy);
    GotoXY (44, 13);
    If I = 2 then Color (LightCyan, Black)
    Else Color (LightGray, Black);
      Write (BCancel);
    If Mouse then MouseShow;
    While true do
      Begin
        Timer;
        If DKeyPressed then C := DReadKey
        Else C := #$FF;
        If Mouse then
          Begin
            MouseReadText (Opt.MX, Opt.MY, MB);
            If (MB and 1 = 1) and (Opt.MY = 13) and (Opt.MX in [30..37]) then
              Begin
                I := 1;
                C := #13
              End;
            If (MB and 1 = 1) and (Opt.MY = 13) and (Opt.MX in [44..53]) then
              C := #27
          End;
        If (C = #27) or ((I = 2) and (C = #13)) then
          Begin
            I := 2;
            C := #13
          End;
        If C = #13 then Break;
        If C = #0 then
          Begin
            C := DReadKey;
            I := 3-I;
            GotoXY (30, 13);
            If I = 1 then Color (LightCyan, Black)
            Else Color (LightGray, Black);
              Write (BCopy);
            GotoXY (44, 13);
            If I = 2 then Color (LightCyan, Black)
            Else Color (LightGray, Black);
              Write (BCancel);
          End
      End;
    CFC := I = 1
  End;

Begin
  SubDirs := 0;
  Files := 0;
  Size := 0;
  FullDir (Path[Opt.CurD]+Dir[Opt.CurD][WinF[Opt.CurD]+WinS[Opt.CurD]].Name, SubDirs, Files,
                                                                      Size);
  FindFirst (Path[1-Opt.CurD]+Dir[Opt.CurD][WinF[Opt.CurD]+WinS[Opt.CurD]].Name,
                                                       anyfile-VolumeID, S);
  If DOSError = 0 then Exit;
  CursorOff;
  SaveScr (Vid^);
  P := CFC;
  If Mouse then
    While MousePressed do;
  LoadScr (Vid^);
  If not P then Exit;
  Window (23, 9, 36, 5, 'Copying...', LightGray, Black);
  GotoXY (27, 11); Write (Per);
  Sz := 0;
  {$I-}
  MkDir (Path[1-Opt.CurD]+Dir[Opt.CurD][WinF[Opt.CurD]+WinS[Opt.CurD]].Name);
  {$I+}
  If IOResult <> 0 then
    Begin
      IOError := MakeError;
      IOErrorFile := Path[1-Opt.CurD]+Dir[Opt.CurD][WinF[Opt.CurD]+WinS[Opt.CurD]].Name
    End;
  If IOError = Ok then
    CopyTree (Path[Opt.CurD]+Dir[Opt.CurD][WinF[Opt.CurD]+WinS[Opt.CurD]].Name,
              Path[1-Opt.CurD]+Dir[Opt.CurD][WinF[Opt.CurD]+WinS[Opt.CurD]].Name, Size, Sz);
  LoadScr (Vid^);
  WinFil;
  Opt.CurD := 1-Opt.CurD;
  FreeList;
  FindFiles;
  SortFiles;
  If Opt.CurD = 0 then Posit (Opt.LFile)
  Else Posit (Opt.RFile);
  WinFil;
  Opt.CurD := 1-Opt.CurD;
  If Path[0][1]=Path[1][1] then Free[1-Opt.CurD] := Free[Opt.CurD];
  ShowSels;
  SaveScr (Vid^);
  If IOError <> Ok then ErrorMessage;
  LoadScr (Vid^)
End;

Procedure MoveTree (Dir1, Dir2 : String; Size : LongInt; Var Sz : LongInt);
Var
  R : Registers;
  F : File;
  S : SearchRec;
Begin
  If Dir1[Length (Dir1)] <> '\' then Dir1 := Dir1+'\';
  If Dir2[Length (Dir2)] <> '\' then Dir2 := Dir2+'\';
  FindFirst (Dir1+'*.*', AnyFile-VolumeID, S);
  While DOSError = 0 do
    Begin
      If S.Attr and Directory = Directory then
        Begin
          If S.Name[1] <> '.' then
            Begin
              {$I-}
              MkDir (Dir2+S.Name);
              {$I+}
              If IOResult <> 0 then
                Begin
                  IOError := MakeError;
                  IOErrorFile := Dir2+S.Name;
                  Exit
                End
            End
        End
      Else
        Begin
          CopyFile (Dir1, Dir2, S.Name, Size, Sz);
          If IOError <> Ok then Exit;
          Assign (F, Dir1+S.Name);
          {$I-}
          SetFAttr (F, Archive);
          {$I+}
          If IOResult <> 0 then
            Begin
              IOError := WriteError;
              IOErrorFile := Dir1+S.Name;
              Exit
            End;
          {$I-}
          Erase (F);
          {$I+}
          If IOResult <> 0 then
            Begin
              IOError := DeleteError;
              IOErrorFile := Dir1+S.Name;
              Exit
            End;
        End;
      FindNext (S)
    End;
  FindFirst (Dir1+'*.*', AnyFile-VolumeID, S);
  While DOSError = 0 do
    Begin
      If (S.Attr and Directory = Directory) and
         (S.Name[1] <> '.') then
         Begin
           MoveTree (Dir1+S.Name, Dir2+S.Name, Size, Sz);
           If IOError = Ok then RmDir (Dir1+S.Name);
           R.AH := $1A;
           R.DS := Seg (S);
           R.DX := Ofs (S);
           MSDOS (R)
         End;
      FindNext (S)
    End
End;

Procedure DirMove;
Var
  SubDirs,
  Files   : Word;
  Sz,
  Size    : LongInt;
  S       : SearchRec;
  P       : Boolean;

  Function CFC : Boolean;
  Var
    C : Char;
    I, J : Byte;
  Begin
    Window (4, 9, 74, 7, 'Move', LightGray, Black);
    GotoXY (8, 11);
    Write ('Move directory '+Dir[Opt.CurD][WinS[Opt.CurD]+WinF[Opt.CurD]].Name+' to');
    GotoXY (8, 12);
    Write (Path[1-Opt.CurD]);
    I := 1;
    GotoXY (30, 13);
    If I = 1 then Color (LightCyan, Black)
    Else Color (LightGray, Black);
      Write (BMove);
    GotoXY (44, 13);
    If I = 2 then Color (LightCyan, Black)
    Else Color (LightGray, Black);
      Write (BCancel);
    While true do
      Begin
        Timer;
        If DKeyPressed then C := DReadKey
        Else C := #$FF;
        If Mouse then
          Begin
            MouseReadText (Opt.MX, Opt.MY, MB);
            If (MB and 1 = 1) and (Opt.MY = 13) and (Opt.MX in [30..37]) then
              Begin
                I := 1;
                C := #13
              End;
            If (MB and 1 = 1) and (Opt.MY = 13) and (Opt.MX in [44..53]) then
              C := #27
          End;
        If (C = #27) or ((I = 2) and (C = #13)) then
          Begin
            I := 2;
            C := #13
          End;
        If C = #13 then Break;
        If C = #0 then
          Begin
            C := DReadKey;
            I := 3-I;
            GotoXY (30, 13);
            If I = 1 then Color (LightCyan, Black)
            Else Color (LightGray, Black);
              Write (BMove);
            GotoXY (44, 13);
            If I = 2 then Color (LightCyan, Black)
            Else Color (LightGray, Black);
              Write (BCancel);
          End
      End;
    CFC := I = 1
  End;

Begin
  SubDirs := 0;
  Files := 0;
  Size := 0;
  FullDir (Path[Opt.CurD]+Dir[Opt.CurD][WinF[Opt.CurD]+WinS[Opt.CurD]].Name, SubDirs, Files,
                                                                      Size);
  FindFirst (Path[1-Opt.CurD]+Dir[Opt.CurD][WinF[Opt.CurD]+WinS[Opt.CurD]].Name,
                                                       anyfile-VolumeID, S);
  If DOSError = 0 then Exit;
  CursorOff;
  SaveScr (Vid^);
  P := CFC;
  If Mouse then
    While MousePressed do;
  LoadScr (Vid^);
  If not P then Exit;
  Window (23, 9, 36, 5, 'Moveing...', LightGray, Black);
  GotoXY (27, 11); Write (Per);
  Sz := 0;
  {$I-}
  MkDir (Path[1-Opt.CurD]+Dir[Opt.CurD][WinF[Opt.CurD]+WinS[Opt.CurD]].Name);
  {$I+}
  If IOResult <> 0 then
    Begin
      IOError := MakeError;
      IOErrorFile := Path[1-Opt.CurD]+Dir[Opt.CurD][WinF[Opt.CurD]+WinS[Opt.CurD]].Name
    End;
  If IOError = Ok then
    MoveTree (Path[Opt.CurD]+Dir[Opt.CurD][WinF[Opt.CurD]+WinS[Opt.CurD]].Name,
              Path[1-Opt.CurD]+Dir[Opt.CurD][WinF[Opt.CurD]+WinS[Opt.CurD]].Name, Size, Sz);
  If IOError = Ok then
    Begin
      {$I-}
      RmDir (Path[Opt.CurD]+Dir[Opt.CurD][WinF[Opt.CurD]+WinS[Opt.CurD]].Name);
      {$I+}
      IF IOResult <> 0 then
        Begin
          IOError := DeleteError;
          IOErrorFile := Path[Opt.CurD]+Dir[Opt.CurD][WinF[Opt.CurD]+WinS[Opt.CurD]].Name
        End
    End;
  LoadScr (Vid^);
  FreeList;
  FindFiles;
  SortFiles;
  WinFil;
  Posit ('..');
  Opt.CurD := 1-Opt.CurD;
  FreeList;
  FindFiles;
  SortFiles;
  If Opt.CurD = 0 then Posit (Opt.LFile)
  Else Posit (Opt.RFile);
  WinFil;
  Opt.CurD := 1-Opt.CurD;
  If Path[0][1]=Path[1][1] then Free[1-Opt.CurD] := Free[Opt.CurD];
  ShowSels;
  SaveScr (Vid^);
  If IOError <> Ok then ErrorMessage;
  LoadScr (Vid^)
End;

Procedure ErrorMessage;
Var
  C : Char;
  X, Y : Byte;
Begin
  If Mouse then
    While MousePressed do;
  If Mouse then MouseHide;
  CursorOff;
  IOErrorFile := FormatStr (IOErrorFile, Length (Message[-IOError]));
  Y := 9;
  X := (80-(Length(IOErrorFile)+8)) div 2;
  Window (X, Y, Length(IOErrorFile)+8, 9, 'Error', Red, White);
  GotoXY (X+4, Y+3);
  Write (Message[-IOError]);
  GotoXY (X+4, Y+4);
  Write (IOErrorFile);
  GotoXY (37, Y+6);
  Color (LightCyan, Black);
    Write (BOK);
  If Mouse then MouseShow;
  Repeat
    Timer;
    If DKeyPressed then C := DReadKey
    Else C := #$FF;
    If Mouse then
      Begin
        MouseReadText (Opt.MX, Opt.MY, MB);
        If MB and 1 = 1 then Break
      End;
    If C in [#13, #27] then Break
  Until false;
  If Mouse then
    While MousePressed do;
  CursorOn (Up, Dn)
End;

Procedure SaveSelList;
Var
  T : Text;
  N : Word;
Begin
  IOError := WriteError;
  IOErrorFile := P+SEL;
  Assign (T, P+SEL);
  {$I-} Rewrite (T); {$I+}
  If IOResult <> 0 then Exit;
  {$I-} WriteLn (T, Path[0]); {$I+}
  If IOResult <> 0 then Exit;
  {$I-} WriteLn (T, Path[1]); {$I+}
  If IOResult <> 0 then Exit;
  If Count[0] > 0 then
    For N := 0 to Count[0]-1 do
      If Dir[0][N].Sel then
        Begin
          {$I-} WriteLn (T, Dir[0][N].Name); {$I+}
          If IOResult <> 0 then Exit
        End;
  {$I-} WriteLn (T, ''); {$I+}
  If IOResult <> 0 then Exit;
  If Count[1] > 0 then
    For N := 0 to Count[1]-1 do
      If Dir[1][N].Sel then
        Begin
          {$I-} WriteLn (T, Dir[1][N].Name); {$I+}
          If IOResult <> 0 then Exit
        End;
  Close (T);
  IOError := Ok
End;

Function FN2 (Name : String; P : Byte) : Word;
Var
  F : Boolean;
  N : Word;
Begin
  F := False;
  N := 0;
  Repeat
    If Dir[P][N].Name = Name then
      Begin
        F := True;
        Break
      End;
    Inc (N)
  Until (N >= Count[P]);
  If F then FN2 := N
  Else FN2 := 65535;
End;

Procedure RestoreSelList;
Type
  TB = Array [1..2000] of String[12];
Var
  T : Text;
  C, Ps,
  N : Word;
  FP1, FP2 : Boolean;
  P1, P2,
  S : String;
  B : ^TB absolute Buf;
Begin
  IOError := ReadError;
  IOErrorFile := P+SEL;
  Assign (T, P+SEL);
  {$I-} Reset (T); {$I+}
  If IOResult <> 0 then Exit;
  {$I-} ReadLn (T, P1); {$I+}
  If IOResult <> 0 then Exit;
  {$I-} ReadLn (T, P2); {$I+}
  If IOResult <> 0 then Exit;
  N := 1;
  While not EOF (T) do
    Begin
      {$I-} ReadLn (T, B^[N]); {$I+}
      If IOResult <> 0 then Exit;
      Inc (N)
    End;
  Close (T);
  IOError := Ok;
  C := N-1;
  FP1 := P1=Path[0];
  FP2 := P2=Path[1];
  S := ' ';
  N := 1;
  While S <> '' do
    Begin
      S := B^[N];
      Ps := FN2(S,0);
      If FP1 and (Ps <> 65535) then
        Dir[0][Ps].Sel := True;
      Inc (N)
    End;
  While N <= C do
    Begin
      S := B^[N];
      Ps := FN2(S,1);
      If FP2 and (Ps <> 65535) then
        Dir[1][Ps].Sel := True;
      Inc (N)
    End
End;

Function ContPrint : Boolean;
Var
  C : Char;
  I : Byte;
Label L;
Begin
  If Mouse then MouseHide;
  GotoXY (27, 12);
  Write ('Maybe printer out of paper.');
  I := 1;
  GotoXY (29, 13);
  If I = 1 then Color (LightCyan, Black)
  Else Color (LightGray, Black);
  Write ('[ Continue ]');
  GotoXY (45, 13);
  If I = 2 then Color (LightCyan, Black)
  Else Color (LightGray, Black);
  Write ('[ Stop ]');
  If Mouse then MouseShow;
  Repeat
    Timer;
    If DKeyPressed then C := UpCase (DReadKey)
    Else C := #$FF;
    If Mouse then
      Begin
        MouseReadText (Opt.MX, Opt.MY, MB);
        If (MB and 1 = 1) and (Opt.MY = 13) and (Opt.MX in [29..40]) then
          C := 'C';
        If (MB and 1 = 1) and (Opt.MY = 13) and (Opt.MX in [45..52]) then
          C := 'S'
      End;
    If C = 'C' then I := 1;
    If C = 'S' then I := 2;
    If C in ['C', 'S', #13] then Break;
    If C = #0 then
      Begin
        C := DReadKey;
        Case C of
          #77 : If I < 2 then Inc (I);
          #75 : If I > 1 then Dec (I)
        End;
        GotoXY (29, 13);
        If I = 1 then Color (LightCyan, Black)
        Else Color (LightGray, Black);
        Write ('[ Continue ]');
        GotoXY (45, 13);
        If I = 2 then Color (LightCyan, Black)
        Else Color (LightGray, Black);
        Write ('[ Stop ]')
      End;
  Until False;
  Color (LightGray, Black);
  GotoXY (27, 12);
  Write (' ':28);
  GotoXY (27, 13);
  Write (' ':28);
L:
  If Mouse then While MousePressed do Timer;
  ContPrint := I = 1
End;

Procedure PrintFile (Source, Name : String;
                    FullSize : LongInt; Var Copied : LongInt);
Var
  K, M    : Byte;
  F       : Text;
  St      : String;
Label
  L;
Begin
  FileMode := 0;
  Assign (F, Source+Name);
  {$I-}
  Reset (F);
  {$I+}
  If IOResult <> 0 then
    Begin
      IOErrorFile := Source+Name;
      IOError := ReadError;
      Exit
    End;
  Repeat
    Timer;
    {$I-}
    ReadLn (F, St);
    {$I+}
    If IOResult <> 0 then
      Begin
        IOErrorFile := Source+Name;
        IOError := ReadError;
        Break
      End;
L:
    {$I-}
    WriteLn (Lst, St);
    {$I+}
    If IOResult <> 0 then
      If ContPrint then Goto L
      Else Break;
    Inc (Copied, Length (St)+2);
    If FullSize = 0 then M := 0
    Else M := Round (Copied/FullSize*20);
    GotoXY (30, 11);
    For K := 1 to M do Write ('');
  Until EOF (F);
  Close (F)
End;

Procedure FilePrint;
Var
  C : Char;
  I, J : Byte;
  P, F : Boolean;
  S, AS: LongInt;
  NumRead, NumWritten,
  K, M, N : Word;
  F1, F2 : File;

  Function CFC : Boolean;
  Var
    C : Char;
    I, J : Byte;
  Begin
    If Mouse then MouseHide;
    Window (22, 9, 39, 6, 'Print', LightGray, Black);
    GotoXY (26, 11);
    Write ('Print the file "'+Dir[Opt.CurD][WinS[Opt.CurD]+WinF[Opt.CurD]].Name+'" ?');
    GotoXY (8, 12);
    I := 1;
    GotoXY (30, 12);
    If I = 1 then Color (LightCyan, Black)
    Else Color (LightGray, Black);
    Write ('[ Print ]');
    GotoXY (44, 12);
    If I = 2 then Color (LightCyan, Black)
    Else Color (LightGray, Black);
    Write ('[ Cancel ]');
    If Mouse then MouseShow;
    While true do
      Begin
        Timer;
        If DKeyPressed then C := DReadKey
        Else C := #$FF;
        If Mouse then
          Begin
            MouseReadText (Opt.MX, Opt.MY, MB);
            If (MB and 1 = 1) and (Opt.MY = 12) and (Opt.MX in [30..38]) then
              Begin
                I := 1;
                C := #13
              End;
            If (MB and 1 = 1) and (Opt.MY = 12) and (Opt.MX in [44..53]) then
              C := #27
          End;
        If (C = #27) or ((I = 2) and (C = #13)) then
          Begin
            I := 2;
            C := #13
          End;
        If C = #13 then Break;
        If C = #0 then
          Begin
            C := DReadKey;
            I := 3-I;
            GotoXY (30, 12);
            If I = 1 then Color (LightCyan, Black)
            Else Color (LightGray, Black);
            Write ('[ Print ]');
            GotoXY (44, 12);
            If I = 2 then Color (LightCyan, Black)
            Else Color (LightGray, Black);
            Write ('[ Cancel ]')
          End
      End;
    If Mouse then While MousePressed do Timer;
    CFC := I = 1
  End;

Begin
  CursorOff;
  SaveScr (Vid^);
  P := CFC;
  If Mouse then
    While MousePressed do;
  LoadScr (Vid^);
  If not P then Exit;
  AS := Dir[Opt.CurD][WinS[Opt.CurD]+WinF[Opt.CurD]].Size;
  S := 0;
  Window (23, 9, 36, 7, 'Printing...', LightGray, Black);
  GotoXY (27, 11); Write (Per);
  PrintFile (Path[Opt.CurD], Dir[Opt.CurD][WinS[Opt.CurD]+WinF[Opt.CurD]].Name, AS, S);
  LoadScr (Vid^);
  If IOError <> Ok then ErrorMessage;
  LoadScr (Vid^)
End;

Function FindView : Byte;
Var
  C    : Char;
  I, J : Byte;
  First,
  Point: Word;

  Procedure Show;
  Var Z : Byte;
  Begin
    If Mouse then MouseHide;
    For Z := 0 to 15 do
      Begin
        If Z+1 > FNC then
          Begin
            Color (Cyan, Black);
            GotoXY (14, 5+Z);
            Write (' ':54);
            Continue
          End;
        GotoXY (14, 5+Z);
        If Z = Point then Color (Black, White)
        Else Color (Cyan, Black);
        If Length (FNA^[First+Z].Name)+
           Length (FDA[FNA^[First+Z].DirN]) < 55 then
          Write (FDA[FNA^[First+Z].DirN]+FNA^[First+Z].Name)
        Else
          Begin
            Write (Copy (FDA[FNA^[First+Z].DirN]+FNA^[First+Z].Name, 1, 53));
            TextColor (Yellow);
            Write ('')
          End;
        While WhereX < 68 do Write (' ')
      End;
    If Mouse then MouseShow
  End;

  Procedure Per (First, Point, FCount : Word);
  Var
    J : Byte;
  Begin
    If Mouse then MouseHide;
    Color (LightCyan, Black);
    GotoXY (68, 5); Write ('');
    GotoXY (68, 20); Write ('');
    For J := 1 to 14 do
      Begin GotoXY (68, 5+J); Write ('') End;
    GotoXY (68, 6+Round((First+Point)/FCount*13)); Write ('');
    If Mouse then MouseShow
  End;

Begin
  CursorOff;
  Color (LightCyan, Black);
  Window (11, 3, 60, 20, LongStr2(FNC)+' files found',
                                                     LightCyan, White);
  First := 1;
  Point := 0;
  Show;
  Per (First, Point, FNC);
  C := #$FF;
  While true do
    Begin
      Timer;
      If DKeyPressed then C := DReadKey
      Else C := #$FF;
      If C = #27 then Begin FindView := 0; Break End;
      If C = #13 then
        Begin
          FindView := 1;
          IOErrorFile := FDA[FNA^[First+Point].DirN]+FNA^[First+Point].Name;
          Break
        End;
      If C = #0 then
        Begin
          C := DReadKey;
          Case C of
            #72 : {UP}
              If Point > 0 then Dec (Point)
              Else If First > 1 then Dec (First);
            #80 : {Down}
              If (Point < 15) and (First+Point < FNC) then
                Inc (Point)
              Else If (Point=15) and (First+Point+1 <= FNC) then
                Inc (First);
            #71 : {Home}
              Begin First := 1; Point := 0 End;
            #79 : {End}
              Begin
                If FNC > 16 then
                  Begin Point := 15; First := FNC - Point End
                Else
                  Begin Point := FNC-1; First := 1 End
              End;
            #73 : {PgUp}
              For I := 1 to 16 do
                If Point > 0 then Dec (Point)
                Else If First > 1 then Dec (First);
            #81 : {PgDn}
              For I := 1 to 16 do
                Begin
                  If (Point < 15) and (First+Point < FNC) then
                    Inc (Point)
                  Else If (Point=15) and (First+Point+1 <= FNC) then
                    Inc (First)
                End;
            #61 : {F3}
              Begin
                FindView := 2;
                IOErrorFile := FDA[FNA^[First+Point].DirN]+FNA^[First+Point].Name;
                Break
              End;
            #62 : {F4}
              Begin
                FindView := 3;
                IOErrorFile := FDA[FNA^[First+Point].DirN]+FNA^[First+Point].Name;
                Break
              End;
          End;
          Show;
          Per (First, Point, FNC)
        End
    End;
  LoadScr (Vid^)
End;

Procedure RecFind (Dir : String; Mask : FName);
Var
  R : Registers;
  S : SearchRec;
Begin
  If Dir[Length (Dir)] <> '\' then Dir := Dir+'\';
  Inc (FDC);
  FDA [FDC] := Dir;
  FindFirst (Dir+Mask, AnyFile-Directory, S);
  Timer;
  GotoXY (32, 12);
  Write (FormatStr(LongStr2(FNC)+' files found', 18));
  While (DOSError = 0) and (FNC < 1000) do
    Begin
      If S.Attr and Directory = 0 then
        Begin
          Inc (FNC);
          With FNA^[FNC] do
            Begin
              Name := S.Name;
              Size := S.Size;
              Time := S.Time;
              DirN := FDC
            End
        End;
      FindNext (S)
    End;
  FindFirst (Dir+'*.*', AnyFile-VolumeID, S);
  While (DOSError = 0) and (FDC < 100) do
    Begin
      If (S.Attr and Directory = Directory) and
         (S.Name[1] <> '.') then
         Begin
           RecFind (Dir+S.Name, Mask);
           R.AH := $1A;
           R.DS := Seg (S);
           R.DX := Ofs (S);
           MSDOS (R)
         End;
      FindNext (S)
    End
End;

Procedure FileFind;
Var S : String;
Begin
  FDC := 0;
  FNC := 0;
  S := Opt.FMask;
  SaveScr (Vid^);
  Window (28, 10, 26, 6, 'Find', LightGray, Black);
  GotoXY (32, 12);
  Write ('Enter the mask');
  GotoXY (32, 13);
  Color (LightCyan, Black);
  Write (S);
  While WhereX < 45 do Write (' ');
  GotoXY (32, 13);
  ReadSK (S, 13);
  LoadScr (Vid^);
  If S = '' then Exit;
  If S[1] = '\' then
    Opt.FMask := Copy(S, 2, Length(S)-1)
  Else
    Opt.FMask := S;
  CursorOff;
  Window (28, 10, 26, 5, 'Find', LightGray, Black);
  GotoXY (32, 12);
  Write (FormatStr(LongStr2(FNC)+' files found',18));
  If S[1] = '\' then
    RecFind (Copy(Path[Opt.CurD],1,3), Opt.FMask)
  Else
    RecFind (Path[Opt.CurD], Opt.FMask);
  LoadScr (Vid^)
End;

Procedure UnderMouse (Var S : String; Var D : Byte);
Var
  N,
  X, Y : Word;
Begin
  MouseReadText (X, Y, MB);
  If X < 41 then D := 0
  Else D := 1;
  If D = 1 then Dec (X, 40);
  S := '';
  {S := Dir[D][WinF[D]+WinS[D]].Name;}
  If (X = 1) or (X = 14) or (X = 27) or (X = 40) then Exit;
  If (Y = 1) or (Y > WC+1) then Exit;
  X := (X - 1) div 13;
  N := Y+WC*X-2;
  If N+WinF[D] <= Count[D]-1 then S := Dir[D][WinF[D]+N].Name
End;

Function MousePressed : Boolean;
Var X, Y, B : Word;
Begin
  MouseReadText (X, Y, B);
  MousePressed := B and 7 <> 0
End;

Procedure SaveSetup;
  Function CFD : Boolean;
  Var
    C : Char;
    I, J : Byte;
  Begin
    If Mouse then MouseHide;
    Window (26, 9, 30, 6, 'Setup', LightGray, Black);
    GotoXY (31, 11);
    Write ('Save current setup?');
    I := 1;
    GotoXY (30, 12);
    If I = 1 then Color (LightCyan, Black)
    Else Color (LightGray, Black);
      Write (BSave);
    GotoXY (42, 12);
    If I = 2 then Color (LightCyan, Black)
    Else Color (LightGray, Black);
      Write (BCancel);
    If Mouse then MouseShow;
    While true do
      Begin
        Timer;
        If DKeyPressed then C := DReadKey
        Else C := #$FF;
        If Mouse then
          Begin
            MouseReadText (Opt.MX, Opt.MY, MB);
            If (MB and 1 = 1) and (Opt.MY = 12) and (Opt.MX in [30..39]) then
              Begin
                I := 1;
                C := #13
              End;
            If (MB and 1 = 1) and (Opt.MY = 12) and (Opt.MX in [42..51]) then
              C := #27
          End;
        If (C = #27) or ((I = 2) and (C = #13)) then
          Begin
            I := 2;
            If (SelNum (Opt.CurD) = 1) and
              (Dir[Opt.CurD][WinS[Opt.CurD]+WinF[Opt.CurD]].Sel = True) then
              Dir[Opt.CurD][WinS[Opt.CurD]+WinF[Opt.CurD]].Sel := False;
            C := #13
          End;
        If C = #13 then Break;
        If C = #0 then
          Begin
            C := DReadKey;
            I := 3-I;
            GotoXY (30, 12);
            If I = 1 then Color (LightCyan, Black)
            Else Color (LightGray, Black);
              Write (BSave);
            GotoXY (42, 12);
            If I = 2 then Color (LightCyan, Black)
            Else Color (LightGray, Black);
              Write (BCancel);
          End
      End;
    If Mouse then While MousePressed do Timer;
    CFD := I = 1
  End;
Begin
  CursorOff;
  If Mouse then MouseHide;
  SaveScr (Vid^);
  If Mouse then MouseShow;
  If not CFD then
    Begin
      LoadScr (Vid^);
      If Mouse then MouseShow;
      Exit
    End;
  SaveCFG (Opt, True);
  If IOError <> Ok then
    ErrorMessage;
  If Mouse then MouseHide;
  LoadScr (Vid^);
  If Mouse then MouseShow
End;

Procedure SortByName;
Var S : String;
Begin
  Less := LessName;
  Opt.Sort := 0;
  S := Dir[Opt.CurD][WinF[Opt.CurD]+WinS[Opt.CurD]].Name;
  SortFiles;
  Posit (S);
  WinFil;
  Opt.CurD := 1-Opt.CurD;
  S := Dir[Opt.CurD][WinF[Opt.CurD]+WinS[Opt.CurD]].Name;
  SortFiles;
  Posit (S);
  WinFil;
  Opt.CurD := 1-Opt.CurD;
  ShowSels
End;

Procedure SortByExtName;
Var S : String;
Begin
  Less := LessExtName;
  Opt.Sort := 1;
  S := Dir[Opt.CurD][WinF[Opt.CurD]+WinS[Opt.CurD]].Name;
  SortFiles;
  Posit (S);
  WinFil;
  Opt.CurD := 1-Opt.CurD;
  S := Dir[Opt.CurD][WinF[Opt.CurD]+WinS[Opt.CurD]].Name;
  SortFiles;
  Posit (S);
  WinFil;
  Opt.CurD := 1-Opt.CurD;
  ShowSels
End;

Procedure SortByTime;
Var S : String;
Begin
  Less := LessTime;
  Opt.Sort := 2;
  S := Dir[Opt.CurD][WinF[Opt.CurD]+WinS[Opt.CurD]].Name;
  SortFiles;
  Posit (S);
  WinFil;
  Opt.CurD := 1-Opt.CurD;
  S := Dir[Opt.CurD][WinF[Opt.CurD]+WinS[Opt.CurD]].Name;
  SortFiles;
  Posit (S);
  WinFil;
  Opt.CurD := 1-Opt.CurD;
  ShowSels
End;

Procedure SortBySize;
Var S : String;
Begin
  Less := LessSize;
  Opt.Sort := 3;
  S := Dir[Opt.CurD][WinF[Opt.CurD]+WinS[Opt.CurD]].Name;
  SortFiles;
  Posit (S);
  WinFil;
  Opt.CurD := 1-Opt.CurD;
  S := Dir[Opt.CurD][WinF[Opt.CurD]+WinS[Opt.CurD]].Name;
  SortFiles;
  Posit (S);
  WinFil;
  Opt.CurD := 1-Opt.CurD;
  ShowSels
End;

Procedure Options;
Var
  Sort,
  Group,
  Point : Byte;
  A3,A4,S3,
  LD,RD : String;
  Status : Byte;
  C : Char;
  SH, MR : Boolean;

  Procedure SortSelWrite;
  Var I : Byte;
  Begin
    If Mouse then MouseHide;
    TAColor (Cyan, Black);
    For I := 0 to 3 do
      Begin
        TAGotoXY (15, 6+I);
        If I = Sort then TAWriteChar (#7)
        Else TAWriteChar (' ')
      End;
    If Mouse then MouseShow
  End;

  Procedure OtherSelWrite;
  Begin
    If Mouse then MouseHide;
    TAColor (Cyan, Black);
    TAGotoXY (34, 6);
    If SH then TAWriteChar ('X')
    Else TAWriteChar (' ');
    TAGotoXY (53, 6);
    If MR then TAWriteChar ('X')
    Else TAWriteChar (' ');
    If Mouse then MouseShow
  End;

  Procedure WriteCS (X, Y : Byte; S : String; B, T : Byte);
  Begin
    While Length (S) < 43 do S := S + ' ';
    GotoXY (X, Y);
    Color (B, T);
    If Mouse then MouseHide;
    Write (S);
    If Mouse then MouseShow
  End;

  Procedure SelectSort;
  Begin
    Point := 1;
    GotoXY (15, 5+Point);
    Repeat
      Timer;
      If DKeyPressed then C := DReadKey
      Else C := #$FF;
      If Mouse then
        Begin
          MouseReadText (Opt.MX, Opt.MY, MB);
          If (MB and 1) = 1 then
            Begin
              If (Opt.MY = 19) and (Opt.MX in [31..36]) then
                C := #13;
              If (Opt.MY = 19) and (Opt.MX in [46..55]) then
                C := #27;
              If (Opt.MX in [14..16]) and (Opt.MY in [6..9]) then
                Begin
                  C := #13;
                  Sort := Opt.MY - 6
                End;
              If (Opt.MX in [33..35]) and (Opt.MY = 6) then
                Begin
                  C := #13;
                  SH := SH xor True
                End;
              If (Opt.MX in [52..54]) and (Opt.MY = 6) then
                Begin
                  C := #13;
                  MR := MR xor True
                End
            End;
        End;
      If C = #13 then Begin Status := 0; Break End;
      If C = #27 then Begin Status := 1; Break End;
      If C = #9 then Begin Status := 2; Break End;
      If C = ' ' then Begin Sort := Point-1; SortSelWrite End;
      If C = #0 then
        Begin
          C := DReadKey;
          Case C of
            #15 : Begin Status := 3; Break End;
            #72 : If Point > 1 then Dec (Point);
            #80 : If Point < 4 then Inc (Point)
          End;
          GotoXY (15, 5+Point);
          SortSelWrite
        End;
    Until False;
    If Mouse then While MousePressed do
  End;

  Procedure SelectOther;
  Begin
    Point := 1;
    GotoXY (34-19*(Point mod 2 - 1), 5 + (Point+1) div 2);
    Repeat
      Timer;
      If DKeyPressed then C := DReadKey
      Else C := #$FF;
      If Mouse then
        Begin
          MouseReadText (Opt.MX, Opt.MY, MB);
          If (MB and 1) = 1 then
            Begin
              If (Opt.MY = 19) and (Opt.MX in [31..36]) then
                C := #13;
              If (Opt.MY = 19) and (Opt.MX in [46..55]) then
                C := #27;
              If (Opt.MX in [14..16]) and (Opt.MY in [6..9]) then
                Begin
                  C := #13;
                  Sort := Opt.MY - 6
                End;
              If (Opt.MX in [33..35]) and (Opt.MY = 6) then
                Begin
                  C := #13;
                  SH := SH xor True
                End;
              If (Opt.MX in [52..54]) and (Opt.MY = 6) then
                Begin
                  C := #13;
                  MR := MR xor True
                End;
            End;
        End;
      If C = #13 then Begin Status := 0; Break End;
      If C = #27 then Begin Status := 1; Break End;
      If C = #9 then Begin Status := 2; Break End;
      If C = ' ' then
        Begin
          Case Point of
            1 : SH := SH xor True;
            2 : MR := MR xor True;
          End;
          OtherSelWrite
        End;
      If C = #0 then
        Begin
          C := DReadKey;
          Case C of
            #15 : Begin Status := 3; Break End;
            #75 : If Point > 1 then Dec (Point);
            #77 : If Point < 2 then Inc (Point);
            #72 : If Point > 3 then Dec (Point, 3);
            #80 : If Point < 1 then Inc (Point, 3)
          End;
          GotoXY (34-19*(Point mod 2 - 1), 5 + (Point+1) div 2);
          OtherSelWrite
        End;
    Until False;
    If Mouse then While MousePressed do
  End;

  Procedure EditWrite;
  Begin
    If Mouse then MouseHide;
    WriteCS (25, 12, A3, Cyan, Black);
    WriteCS (25, 13, A4, Cyan, Black);
    WriteCS (25, 14, S3, Cyan, Black);
    WriteCS (25, 15, LD, Cyan, Black);
    WriteCS (25, 16, RD, Cyan, Black);
    If Mouse then MouseShow
  End;

  Procedure EditNames;
  Begin
    Point := 1;
    Repeat
      EditWrite;
      Case Point of
        1 : WriteCS (25, 11+Point, A3, Black, LightCyan);
        2 : WriteCS (25, 11+Point, A4, Black, LightCyan);
        3 : WriteCS (25, 11+Point, S3, Black, LightCyan);
        4 : WriteCS (25, 11+Point, LD, Black, LightCyan);
        5 : WriteCS (25, 11+Point, RD, Black, LightCyan)
      End;
      GotoXY (25, 11+Point);
      Case Point of
        1 : ReadSKT (A3, 43, Status);
        2 : ReadSKT (A4, 43, Status);
        3 : ReadSKT (S3, 43, Status);
        4 : ReadSKT (LD, 43, Status);
        5 : ReadSKT (RD, 43, Status);
      End;
      If LD[Length(LD)] <> '\' then LD := LD + '\';
      If RD[Length(RD)] <> '\' then RD := RD + '\';
      Case Status of
        0..3: Break;
        4 : If Point > 1 then Dec (Point);
        5 : If Point < 5 then Inc (Point)
      End
    Until False;
    EditWrite
  End;

Var
  S : String;
  Opt2 : OptRec;

Begin
  If Mouse then MouseHide;
  SaveScr (Vid^);
  LoadCFG (Opt2);
  LD := Opt2.LDir;
  RD := Opt2.RDir;
  Window (6, 3, 70, 19, 'Options', LightCyan, Black);
  GotoXY (11, 5); Write (' Sort by Ŀ  Other Ŀ');
  GotoXY (11, 6); Write ('  ( ) name         [ ] Hidden files   [ ] Lft-Hnd Mouse ');
  GotoXY (11, 7); Write ('  ( ) extension                                         ');
  GotoXY (11, 8); Write ('  ( ) date&time                                         ');
  GotoXY (11, 9); Write ('  ( ) size                                              ');
  GotoXY (11, 10);Write (' ');
  GotoXY (11, 11);Write (' External programs & Startup directories Ŀ');
  GotoXY (11, 12);Write ('  Alt-F3   :');                   GotoXY (70, 12);Write ('');
  GotoXY (11, 13);Write ('  Alt-F4   :');                   GotoXY (70, 13);Write ('');
  GotoXY (11, 14);Write ('  Shift-F3 :');                   GotoXY (70, 14);Write ('');
  GotoXY (11, 15);Write ('  Left dir :');                   GotoXY (70, 15);Write ('');
  GotoXY (11, 16);Write ('  Rght dir :');                   GotoXY (70, 16);Write ('');
  GotoXY (11, 17);Write ('');
  Sort := Opt.Sort;
  Color (LightCyan, Yellow);
  GotoXY (31, 19);Write ('[ Ok ]');
  Color (LightCyan, Black);
  GotoXY (46, 19);Write ('[ Cancel ]');
  A3 := Opt2.ExView1;
  A4 := Opt2.ExEdit1;
  S3 := Opt2.ExView2;
  SH := Opt2.ShowHidden;
  MR := Opt2.MouseReversed;
  SortSelWrite;
  OtherSelWrite;
  EditWrite;
  Group := 1;
  Status := $FF;
  If Mouse then MouseShow;
  Repeat
    If DKeyPressed then C := DReadKey
    Else C := #$FF;
    If (C = #13) or (Status = 0) then
      Begin
        Opt2.ExView1 := A3;
        Opt2.ExEdit1 := A4;
        Opt2.ExView2 := S3;
        Opt2.MouseReversed := MR;
        Opt2.LDir := LD;
        Opt2.RDir := RD;
        If Opt2.ShowHidden <> SH then
          Begin
            Opt2.ShowHidden := SH;
            SH := True
          End
        Else
          SH := False;
        Opt2.Sort := Sort;
        Opt2.LFile := '..';
        Opt2.RFile := '..';
        SaveCFG (Opt2, False);
        If IOError <> Ok then
          ErrorMessage;
        Opt.ExView1 := Opt2.ExView1;
        Opt.ExView2 := Opt2.ExView2;
        Opt.ExEdit1 := Opt2.ExEdit1;
        Opt.MouseReversed := Opt2.MouseReversed;
        Opt.ShowHidden := Opt2.ShowHidden;
        LoadScr (Vid^);
        If SH then
          Begin
            Opt.ShowHidden := Opt2.ShowHidden;
            FindFiles;
            Case Sort of
              0 : SortByName;
              1 : SortByExtName;
              2 : SortByTime;
              3 : SortBySize
            End;
            Posit ('..');
            WinFil;
            Opt.CurD := 1-Opt.CurD;
            FindFiles;
            Case Sort of
              0 : SortByName;
              1 : SortByExtName;
              2 : SortByTime;
              3 : SortBySize
            End;
            Posit ('..');
            WinFil;
            Opt.CurD := 1-Opt.CurD;
            ShowSels;
            Exit
          End;
        Case Sort of
          0 : SortByName;
          1 : SortByExtName;
          2 : SortByTime;
          3 : SortBySize
        End;
        Exit
      End;
    If (C = #27) or (Status = 1) then Break;
    If (C = #9) or (Status = 2) then
      Begin
        If Group < 3 then Inc (Group)
        Else Group := 1;
      End;
    If C = #0 then
      Begin
        C := DReadKey;
        Case C of
          #15 : If Group > 1 then Dec (Group)
                Else Group := 3;
        End
      End;
    If Status = 3 then
       If Group > 1 then Dec (Group) Else Group := 3;
    Case Group of
      1 : SelectSort;
      2 : SelectOther;
      3 : EditNames
    End
  Until False;
  LoadScr (Vid^)
End;
{
Function Contain (Name, Str : String) : Boolean;
Var
  F : File;
  B : Boolean;
  S : String;
  C : Char;
  I, NumRead : Word;
Label
  L;
Begin
  B := False;
  Assign (F, Name);
  FileMode := 0;
  Reset (F, 1);
  FileMode := 2;
  If FileSize(F) < Length(Str) then Goto L;
  S := '';
  Repeat
    BlockRead (F, Buf^, SizeOf(Buf), NumRead);
    For I := 0 to NumRead-1 do
      Begin
        C := Char(Buf^[I]);
        If Length(S) < Length(Str) then S := S+C;
        If S = Str then
          Begin
            B := True;
            Break
          End;
        If S[0] = Str[0] then S := Copy (S, 2, Length(S)-1)
      End
  Until NumRead < SizeOf(Buf);
L:
  Close (F);
  Contain := B
End;
}
Procedure Memory;
Var T : Text;
Begin
  IOErrorFile := P+BAT;
  IOError := WriteError;
  Assign (T, P+BAT);
  {$I-} Rewrite (T); {$I+}
  If IOResult <> 0 then Exit;
  {$I-} WriteLn (T, '@ECHO OFF'); {$I+}
  If IOResult <> 0 then Exit;
  {$I-} WriteLn (T, DM+'/C>'+P+FM); {$I+}
  If IOResult <> 0 then Exit;
  {$I-} WriteLn (T, P+View+' '+P+FM); {$I+}
  If IOResult <> 0 then Exit;
  Close (T);
  IOError := Ok
End;

Procedure FExt;
Var T : Text;
Begin
  IOErrorFile := P+BAT;
  IOError := WriteError;
  Assign (T, P+BAT);
  {$I-} Rewrite (T); {$I+}
  If IOResult <> 0 then Exit;
  {$I-} WriteLn (T, '@ECHO OFF'); {$I+}
  If IOResult <> 0 then Exit;
  {$I-} If Pos('.',CS) > 0 then
    WriteLn (T, S); {$I+}
  If IOResult <> 0 then Exit;
  Close (T);
  IOError := Ok
End;

Begin
  New (Buf);
  New (Scr);
  New (Vid);
  InputCase := 1;
  WH := GetRowNum;
  WC := WH-7;
  WS := 3*WC;
  WOH := WH
End.
